//---------------------------------------------------------------------------

#ifndef FrameRateEmulation_H
#define FrameRateEmulation_H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "VidGrab.hpp"
#include <Buttons.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
const FreeHandMouseMax = 1000;

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TImage *Image1;
        TLabel *Label3;
        TLabel *Label5;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label4;
        TLabel *Label6;
        TGroupBox *GroupBox2;
        TLabel *Label7;
        TEdit *edtFrameRate;
        TButton *btnFrameRate;
        TGroupBox *GroupBox1;
        TButton *btnCaptureToImage;
        TButton *btnCaptureToJPEG;
        TButton *btnCaptureToBMP;
        TCheckBox *chkTextOverlay;
        TCheckBox *chkFreeHandEnabled;
        TButton *btnEraseDrawing;
        TGroupBox *GroupBox3;
        TComboBox *cmbVideoDevices;
        TComboBox *cmbAnalogVideoStandards;
        TComboBox *cmbVideoInputs;
        TComboBox *cmbVideoSizes;
        TButton *btnStart;
        TButton *btnStop;
        TButton *btnPause;
        TButton *btnResume;
        TVideoGrabber *VideoGrabber1;
        TVideoGrabber *VideoGrabber2;
        TMemo *Memo1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall VideoGrabber1VideoDeviceSelected(TObject *Sender);
        void __fastcall btnStartClick(TObject *Sender);
        void __fastcall btnPauseClick(TObject *Sender);
        void __fastcall btnResumeClick(TObject *Sender);
        void __fastcall btnStopClick(TObject *Sender);
        void __fastcall cmbVideoDevicesChange(TObject *Sender);
        void __fastcall cmbVideoSizesChange(TObject *Sender);
        void __fastcall cmbVideoInputsChange(TObject *Sender);
        void __fastcall cmbAnalogVideoStandardsChange(TObject *Sender);
        void __fastcall chkTextOverlayClick(TObject *Sender);
        void __fastcall btnEraseDrawingClick(TObject *Sender);
        void __fastcall VideoGrabber2FrameOverlayUsingDC(TObject *Sender,
          HDC Dc, DWORD FrameNumber, Int64 FrameTime, int FrameId);
        void __fastcall VideoGrabber2MouseDown(TObject *Sender,
          int VideoWindow, TMouseButton Button, TShiftState Shift, int X,
          int Y);
        void __fastcall VideoGrabber2MouseMove(TObject *Sender,
          int VideoWindow, TShiftState Shift, int X, int Y);
        void __fastcall VideoGrabber2MouseUp(TObject *Sender,
          int VideoWindow, TMouseButton Button, TShiftState Shift, int X,
          int Y);
        void __fastcall btnCaptureToImageClick(TObject *Sender);
        void __fastcall btnCaptureToJPEGClick(TObject *Sender);
        void __fastcall btnCaptureToBMPClick(TObject *Sender);
        void __fastcall VideoGrabber2FrameCaptureCompleted(TObject *Sender,
          Pointer FrameBitmap, int BitmapWidth, int BitmapHeight,
          DWORD FrameNumber, Int64 FrameTime, TFrameCaptureDest DestType,
          AnsiString FileName, bool Success, int FrameId);
        void __fastcall btnFrameRateClick(TObject *Sender);
private:
        TRect FreeHandMouseDrawing[FreeHandMouseMax];
        int iFreeHandMouseDrawing;
        bool FreeHandMouseDrawingEnabled;
public:
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
