//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SynchronizedPlayers_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnPlayerOpenFileClick(TObject *Sender)
{
   dlgOpen->FileName = "*.mpg;*.mpeg;*.avi;*.wav;*.mp3;*.asf;*.wmv;*.vob";
   if (dlgOpen->Execute()) {
      edtFileName->Text = dlgOpen->FileName;
   }
}
//---------------------------------------------------------------------------

void __fastcall SetupPlayer (TVideoGrabber *VideoGrabber, AnsiString VideoClip)
{
   VideoGrabber->Synchronized = true;
   VideoGrabber->TextOverlay_Enabled = true;
   VideoGrabber->AutoStartPlayer = false;
   VideoGrabber->PlayerFileName = VideoClip;
}
//---------------------------------------------------------------------------

// NOTE 1:
// when its Synchronized property is enabled, invoking the command applied on one component
// is applied to all the other components that have also their Synchronized property enabled
// (within the same application).

// NOTE 2:
// the trackbars are associated to the TVideoGrabber components through their "PlayerTrackbar" property

void __fastcall TForm1::btnOpenClick(TObject *Sender)
{
   SetupPlayer (VideoGrabber1, edtFileName->Text);
   SetupPlayer (VideoGrabber2, edtFileName->Text);
   SetupPlayer (VideoGrabber3, edtFileName->Text);
   SetupPlayer (VideoGrabber4, edtFileName->Text);

   VideoGrabber1->ClosePlayer();
   VideoGrabber1->OpenPlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnCloseClick(TObject *Sender)
{
   VideoGrabber1->ClosePlayer();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnBackwardsClick(TObject *Sender)
{
   VideoGrabber1->RunPlayerBackwards();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnPauseClick(TObject *Sender)
{
   VideoGrabber1->PausePlayer();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnStopClick(TObject *Sender)
{
   VideoGrabber1->StopPlayer();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnPlayClick(TObject *Sender)
{
   VideoGrabber1->RunPlayer();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnREWClick(TObject *Sender)
{
   VideoGrabber1->RewindPlayer();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnFFClick(TObject *Sender)
{
   VideoGrabber1->FastForwardPlayer();
}

