unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Buttons, Menus, VidGrab, Jpeg, ShellAPI;

const
  FreeHandMouseMax = 1000;

type
  TfrmMainForm = class(TForm)
    btnPlayerBackwards: TSpeedButton;
    btnPlayerFastForward: TSpeedButton;
    btnPlayerPause: TSpeedButton;
    btnPlayerRewind: TSpeedButton;
    btnPlayerStartPlaying: TSpeedButton;
    btnPlayerStop: TSpeedButton;
    dlgOpen: TOpenDialog;
    edtFrameCount: TEdit;
    edtStoragePath: TEdit;
    edtDVDateTime: TEdit;
    grbPlayerControl: TGroupBox;
    Label52: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    mmoLog: TMemo;
    mnuAbout: TMenuItem;
    mnuExit: TMenuItem;
    mnuFile: TMenuItem;
    mnuSendDVCommands: TMenuItem;
    mnuDVFF: TMenuItem;
    mnuDVFreeze: TMenuItem;
    mnuDVPlay: TMenuItem;
    mnuDVPlayfastestfwd: TMenuItem;
    mnuDVPlayfastestrev: TMenuItem;
    mnuDVPlayslowestfwd: TMenuItem;
    mnuDVPlayslowestrev: TMenuItem;
    mnuDVRecord: TMenuItem;
    mnuDVRecordfreeze: TMenuItem;
    mnuDVRew: TMenuItem;
    mnuDVStepFwd: TMenuItem;
    mnuDVStepRev: TMenuItem;
    mnuDVStop: TMenuItem;
    tbrPlayerProgress: TTrackBar;
    mnuDVThaw: TMenuItem;
    mnuDVRecordStrobe: TMenuItem;
    mnuDVModeShuttle: TMenuItem;
    VideoGrabber: TVideoGrabber;
    pctMain: TPageControl;
    tbsVideoDevice: TTabSheet;
    rdgPreferredVideoSize: TRadioGroup;
    chkStretchPreferredVideoSize: TCheckBox;
    grbVideoDeviceDialogs: TGroupBox;
    btnDeviceDialog: TButton;
    btnStreamDialog: TButton;
    btnVideoQualityDialog: TButton;
    btnCameraControlDialog: TButton;
    btnVideoControlDialog: TButton;
    tbsAudio: TTabSheet;
    grbAudioRendering: TGroupBox;
    Label1: TLabel;
    Label17: TLabel;
    tbrAudioVolume: TTrackBar;
    tbrAudioBalance: TTrackBar;
    grbAudioCaptureDevice: TGroupBox;
    Label26: TLabel;
    Label49: TLabel;
    Label36: TLabel;
    cboAudioDevices: TComboBox;
    cboAudioInputs: TComboBox;
    tbrAudioInputLevel: TTrackBar;
    tbrAudioInputBalance: TTrackBar;
    chkAudioInputMono: TCheckBox;
    tbsRecording: TTabSheet;
    Label38: TLabel;
    Label37: TLabel;
    btnStopRecording: TButton;
    grbCompression: TGroupBox;
    Label6: TLabel;
    Label16: TLabel;
    cboVideoCompressors: TComboBox;
    btnVideoCompressorSettings: TButton;
    cboAudioCompressors: TComboBox;
    btnAudioCompressorSettings: TButton;
    rdgCompressMode: TRadioGroup;
    rdgCompressType: TRadioGroup;
    grbAVIPauseResume: TGroupBox;
    chkRecordingCanPause: TCheckBox;
    btnPauseRecording: TButton;
    btnResumeRecording: TButton;
    rdgRecordingMethod: TRadioGroup;
    btnStartRecordingImmediately: TBitBtn;
    tbsASFStreaming: TTabSheet;
    rdgNetworkStreaming: TRadioGroup;
    grbDirectASFStreaming: TGroupBox;
    Label10: TLabel;
    Label24: TLabel;
    edtNetworkPort: TEdit;
    edtNetworkMaxUsers: TEdit;
    grbASFStreamingToWMServer: TGroupBox;
    Label32: TLabel;
    edtPublishingPoint: TEdit;
    grbASFSettings: TGroupBox;
    Label39: TLabel;
    Label44: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    edtASFVideoWidth: TEdit;
    edtASFVideoHeight: TEdit;
    edtASFVideoBitRate: TEdit;
    edtASFVideoMaxKeyFrameSpacing: TEdit;
    edtASFVideoQuality: TEdit;
    edtASFAudioChannels: TEdit;
    grbASFProfiles: TGroupBox;
    Label34: TLabel;
    lsbProfiles: TListBox;
    btnShowProfilesList: TButton;
    edtProfileIndex: TEdit;
    tbsPlayer: TTabSheet;
    btnOpenLastClipRecorded: TSpeedButton;
    btnPlayerOpenFile: TSpeedButton;
    Label23: TLabel;
    Label8: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    btnPlayerOpenStreamingURL: TSpeedButton;
    btnPlayerCloseClip: TButton;
    edtPlayerFastSeekSpeed: TEdit;
    edtPlayerSpeedRatio: TEdit;
    updPlayerSpeedRatio: TUpDown;
    updPlayerFastSeekSpeed: TUpDown;
    btnAutoPlay: TCheckBox;
    edtPlayerClip: TEdit;
    tbsFrameGrabber: TTabSheet;
    Label42: TLabel;
    Label43: TLabel;
    rgdFrameGrabberFormat: TRadioGroup;
    rgdFrameGrabber: TRadioGroup;
    tbsClipReencoding: TTabSheet;
    TabSheet1: TTabSheet;
    mmoSensitivityGrid: TMemo;
    mmoMotionGrid: TMemo;
    tbsFrameOverlay: TTabSheet;
    Label47: TLabel;
    lblFrameOverlayRequiresFrameGrabber: TLabel;
    grbTextOverlay: TGroupBox;
    Label13: TLabel;
    Label20: TLabel;
    Label22: TLabel;
    rdgTextOverlayAlign: TRadioGroup;
    chkTextOverlayEnabled: TCheckBox;
    chkTextOverlayTransparent: TCheckBox;
    mmoTextOverlayString: TMemo;
    edtTextOverlayTop: TEdit;
    edtTextOverlayLeft: TEdit;
    edtTextOverlayWidth: TEdit;
    grbFreeHand: TGroupBox;
    chkFreeHandEnabled: TCheckBox;
    btnFreeHandErase: TButton;
    grbLinesOverlay: TGroupBox;
    chkLinesOverlayEnabled: TCheckBox;
    grbShapeOverlay: TGroupBox;
    shpShapeOverlay: TShape;
    Label27: TLabel;
    edtShapeOverlayLeft: TEdit;
    edtShapeOverlayTop: TEdit;
    edtShapeOverlayWidth: TEdit;
    edtShapeOverlayHeight: TEdit;
    chkShapeOverlayEnabled: TCheckBox;
    tbsVideoProcessing: TTabSheet;
    tbsDisplay: TTabSheet;
    chk1stVideoWindowActive: TCheckBox;
    grbMainVideoWindow: TGroupBox;
    chk1stEmbedded: TCheckBox;
    chk1stFullScreen: TCheckBox;
    chk1stStayOnTop: TCheckBox;
    chk1stUseVideoPort: TCheckBox;
    rdg1stDisplayedOn: TRadioGroup;
    chk1stMouseMovesWindow: TCheckBox;
    chk1stAutoSize: TCheckBox;
    chk1stKeepAspectRatio: TCheckBox;
    btnEG1stNewLocation: TButton;
    btnEG1stNewLocation2: TButton;
    chk2ndVideoWindowActive: TCheckBox;
    grb2ndVideoWindow: TGroupBox;
    chk2ndEmbedded: TCheckBox;
    chk2ndFullScreen: TCheckBox;
    chk2ndStayOnTop: TCheckBox;
    chk2ndUseVideoPort: TCheckBox;
    rdg2ndDisplayedOn: TRadioGroup;
    chk2ndMouseMovesWindow: TCheckBox;
    chk2ndAutoSize: TCheckBox;
    chk2ndKeepAspectRatio: TCheckBox;
    btnEG2ndNewLocation: TButton;
    btnEG2ndNewLocation2: TButton;
    rdgVideoRenderer: TRadioGroup;
    chkTransparency: TCheckBox;
    chkBorder: TCheckBox;
    tbsTVTuner: TTabSheet;
    Label50: TLabel;
    lblTVTunerAvailable: TLabel;
    grbTunerCountryCode: TGroupBox;
    grbCountryCode: TGroupBox;
    edtCountryCode: TEdit;
    btnSetCountryCode: TButton;
    rdgTunerInputType: TRadioGroup;
    grbTVChannel: TGroupBox;
    edtTVChannel: TEdit;
    btnSelect: TButton;
    grbFrequencyOverride: TGroupBox;
    edtChannelFrequency: TEdit;
    btnDeleteFrequencyOverride: TButton;
    chkSetFrequencyOverride: TButton;
    chkEnableFrequencyOverrides: TCheckBox;
    grbTVScan: TGroupBox;
    btnStopScan: TButton;
    btnStartScan: TButton;
    btnResetAllOverrides: TButton;
    mmoChannelLog: TMemo;
    grbColorFiltering: TRadioGroup;
    chkPlayerAudioRendering: TCheckBox;
    btnViewDirectNetworkStreaming: TButton;
    grbFileNames: TGroupBox;
    rdgAutoFileName: TRadioGroup;
    Label46: TLabel;
    edtAVIAutoFilePrefix: TEdit;
    grbOneShot: TGroupBox;
    edtUseThisFileName: TEdit;
    btnOneShotTBitmap: TButton;
    btnOneShotBMPFile: TButton;
    btnOneShotJPEGFile: TButton;
    chkUseThisFileName: TCheckBox;
    grbBurstMode: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    btnBurstModeBMPFile: TButton;
    btnBurstModeJPEGFile: TButton;
    edtBurstCount: TEdit;
    edtBurstInterval: TEdit;
    btnBurstModeStop: TButton;
    btnBurstModeTBitmap: TButton;
    grbZoomSize: TGroupBox;
    Label12: TLabel;
    tbrCaptureZoomSize: TTrackBar;
    edtCaptureZoomSize: TEdit;
    btnResetCaptureZoomSize: TButton;
    mmoFrameCaptureLog: TMemo;
    btnStartRecordingControlled: TBitBtn;
    chkRefreshPausedDisplay: TCheckBox;
    grbReencodingSettings: TGroupBox;
    chkIncludeVideoStream: TCheckBox;
    chkIncludeAudioStream: TCheckBox;
    chkUseCurrentVideoCompressor: TCheckBox;
    chkUseCurrentAudioCompressor: TCheckBox;
    chkUseFrameGrabber: TCheckBox;
    chkWMVOutput: TCheckBox;
    btnSourceVideoClip: TSpeedButton;
    edtSourceVideoClip: TEdit;
    edtDestinationVideoClip: TEdit;
    Label75: TLabel;
    Label45: TLabel;
    grbStartStopTime: TGroupBox;
    Label78: TLabel;
    Label79: TLabel;
    Label77: TLabel;
    edtStartTime: TEdit;
    edtDuration: TEdit;
    edtStopTime: TEdit;
    btnDuration: TButton;
    btnStartReencoding: TButton;
    btnStopReencoding: TButton;
    rdgReencodingMethod: TRadioGroup;
    chkAVISaveToThisFile: TCheckBox;
    edtRecordingFileName: TEdit;
    chkOpenDML: TCheckBox;
    chkPreallocFile: TCheckBox;
    edtPreallocSize: TEdit;
    Label11: TLabel;
    btnCreatePreallocFileNow: TButton;
    rdgDVPlaybackSize: TRadioGroup;
    Label81: TLabel;
    btnOpenLastClipPlayed: TSpeedButton;
    cmbASFDeinterlaceMode: TComboBox;
    Label83: TLabel;
    chkASFFixedFrameRate: TCheckBox;
    chkSetLogo: TCheckBox;
    imgLogo: TImage;
    grbVsVideoCaptureDevice: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    cboVideoInputs: TComboBox;
    cboVideoSizes: TComboBox;
    cboVideoSubtypes: TComboBox;
    cboAnalogVideoStandard: TComboBox;
    cboVideoDevices: TComboBox;
    chkReduceDVFrameRate: TCheckBox;
    btnAutoRefreshPreview: TCheckBox;
    grbVsScreenRecording: TGroupBox;
    chkScreenRecordingWithCursor: TCheckBox;
    grbVsFileOrUrl: TGroupBox;
    edtVideoSourceFileOrUrl: TEdit;
    grbCropping: TGroupBox;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label84: TLabel;
    Label88: TLabel;
    chkCroppingEnabled: TCheckBox;
    trkCroppingX: TTrackBar;
    trkCroppingY: TTrackBar;
    edtCroppingWidth: TEdit;
    edtCroppingHeight: TEdit;
    trkCroppingZoom: TTrackBar;
    chkCroppingOutbounds: TCheckBox;
    btnCroppingZoomReset: TButton;
    chkRenderAudioDevice: TCheckBox;
    grbVMR9Adjust: TGroupBox;
    Label7: TLabel;
    tbrVMR9Brightness: TTrackBar;
    tbrVMR9Contrast: TTrackBar;
    tbrVMR9Saturation: TTrackBar;
    tbrVMR9Hue: TTrackBar;
    vmr9FixRange: TCheckBox;
    Label21: TLabel;
    chkChangeCursor: TCheckBox;
    btnSelectFileOrUrl: TSpeedButton;
    grbVideoSource: TGroupBox;
    cboVideoSource: TComboBox;
    grbPreview: TGroupBox;
    btnStartPreview: TBitBtn;
    btnStopPreview: TButton;
    grbFrameRate: TGroupBox;
    edtFrameRate: TEdit;
    btnFrameRate: TButton;
    chkAudioRecording: TCheckBox;
    cboAudioFormats: TComboBox;
    chkPreserveNativeFormat: TCheckBox;
    Label5: TLabel;
    chkMuteAudioRendering: TCheckBox;
    btnRenewRecordingFile: TButton;
    Label53: TLabel;
    lblMotionDetectorRequiresFrameGrabber: TLabel;
    chkMotionDetectionEnabled: TCheckBox;
    chkReduceVideoNoise: TCheckBox;
    btnShowGridDialog: TButton;
    Label54: TLabel;
    chkCompareRed: TCheckBox;
    chkCompareGreen: TCheckBox;
    chkCompareBlue: TCheckBox;
    chk_GreyScale: TCheckBox;
    imgMotionDetected: TImage;
    grbMotionRatio: TGroupBox;
    shpMotionDetected: TShape;
    edtMotionRatio: TEdit;
    grbXYMaxMotion: TGroupBox;
    edtMaxMotionXY: TEdit;
    edtMaxMotionCoord: TEdit;
    grbCellsSensitivity: TGroupBox;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    edtXCell: TEdit;
    updXCell: TUpDown;
    edtYCell: TEdit;
    updYCell: TUpDown;
    edtCellSensitivity: TEdit;
    updCellSensitivity: TUpDown;
    btnSetCellsSensitivity: TButton;
    grbGridSize: TGroupBox;
    Label55: TLabel;
    Label56: TLabel;
    edtGridColCount: TEdit;
    updGridColCount: TUpDown;
    edtGridRowCount: TEdit;
    updGridRowCount: TUpDown;
    btnApplyGridSize: TButton;
    grbGridString: TGroupBox;
    Label51: TLabel;
    lblGridValid: TLabel;
    shpGridValid: TShape;
    edtGrid: TEdit;
    updGlobalGridSensitivity: TUpDown;
    Label28: TLabel;
    grbSoftwareVideoProcessing: TGroupBox;
    rdgVideoRotation: TRadioGroup;
    rdgDeinterlacing: TRadioGroup;
    chkFlipVertical: TCheckBox;
    chkFlipHorizontal: TCheckBox;
    chkGreyScale: TCheckBox;
    chkInvertColors: TCheckBox;
    btnResetAll: TButton;
    tbrBrightness: TTrackBar;
    tbrConstrast: TTrackBar;
    tbrSaturation: TTrackBar;
    tbrHue: TTrackBar;
    Label31: TLabel;
    btnNativeFormat: TButton;
    Label3: TLabel;
    btnOpenClip: TButton;
    btnGetClipDuration: TButton;
    grbBitmapOverlay: TGroupBox;
    imgBitmapOverlay: TImage;
    Label25: TLabel;
    Label48: TLabel;
    Label82: TLabel;
    btnLoadImageOverlayFromFile: TSpeedButton;
    chkBitmapOverlayEnabled: TCheckBox;
    tbrBitmapOverlaySize: TTrackBar;
    btnBitmapOverlayResetSize: TButton;
    edtBitmapOverlaySize: TEdit;
    edtBitmapOvlerlayLeft: TEdit;
    edtBitmapOvlerlayTop: TEdit;
    edtBitmapOverlayAlphaBlend: TEdit;
    updBitmapOverlayAlphaBend: TUpDown;
    chkBitmapOverlayAlphaBlend: TCheckBox;
    chkBitmapOverlayTransparent: TCheckBox;
    chkBitmapOverlayUseTransparentColor: TCheckBox;
    cmbBitmapOverlayTransparentColor: TComboBox;
    GroupBox1: TGroupBox;
    chkMultiplexedAutoSwitch: TCheckBox;
    chkMultiplexedInputEmulation: TCheckBox;
    chkTriggered: TCheckBox;
    btnTriggerNow: TButton;
    procedure btnAudioCompressorSettingsClick(Sender: TObject);
    procedure btnAutoPlayClick(Sender: TObject);
    procedure btnAutoRefreshPreviewClick(Sender: TObject);
    procedure btnBitmapOverlayResetSizeClick(Sender: TObject);
    procedure btnBurstModeBMPFileClick(Sender: TObject);
    procedure btnBurstModeJPEGFileClick(Sender: TObject);
    procedure btnBurstModeStopClick(Sender: TObject);
    procedure btnBurstModeTBitmapClick(Sender: TObject);
    procedure btnCameraControlDialogClick(Sender: TObject);
    procedure btnDeleteFrequencyOverrideClick(Sender: TObject);
    procedure btnDeviceDialogClick(Sender: TObject);
    procedure btnEG1stNewLocation2Click(Sender: TObject);
    procedure btnEG1stNewLocationClick(Sender: TObject);
    procedure btnEG2ndNewLocation2Click(Sender: TObject);
    procedure btnEG2ndNewLocationClick(Sender: TObject);
    procedure btnFrameRateClick(Sender: TObject);
    procedure btnFreeHandEraseClick(Sender: TObject);
    procedure btnOneShotBMPFileClick(Sender: TObject);
    procedure btnOneShotJPEGFileClick(Sender: TObject);
    procedure btnOneShotTBitmapClick(Sender: TObject);
    procedure btnPauseRecordingClick(Sender: TObject);
    procedure btnPlayerBackwardsClick(Sender: TObject);
    procedure btnPlayerCloseClipClick(Sender: TObject);
    procedure btnPlayerFastForwardClick(Sender: TObject);
    procedure btnOpenLastClipRecordedClick(Sender: TObject);
    procedure btnPlayerOpenFileClick(Sender: TObject);
    procedure btnPlayerPauseClick(Sender: TObject);
    procedure btnPlayerRewindClick(Sender: TObject);
    procedure btnPlayerStartPlayingClick(Sender: TObject);
    procedure btnPlayerStopClick(Sender: TObject);
    procedure btnResetAllClick(Sender: TObject);
    procedure btnResetAllOverridesClick(Sender: TObject);
    procedure btnResetCaptureZoomSizeClick(Sender: TObject);
    procedure btnResumeRecordingClick(Sender: TObject);
    procedure btnSelectClick(Sender: TObject);
    procedure btnSetCountryCodeClick(Sender: TObject);
    procedure btnStartRecordingImmediatelyClick(Sender: TObject);
    procedure btnStartPreviewClick(Sender: TObject);
    procedure btnStartScanClick(Sender: TObject);
    procedure btnStopRecordingClick(Sender: TObject);
    procedure btnStopPreviewClick(Sender: TObject);
    procedure btnStopScanClick(Sender: TObject);
    procedure btnStreamDialogClick(Sender: TObject);
    procedure btnVideoCompressorSettingsClick(Sender: TObject);
    procedure btnVideoControlDialogClick(Sender: TObject);
    procedure btnVideoQualityDialogClick(Sender: TObject);
    procedure cboAnalogVideoStandardChange(Sender: TObject);
    procedure cboAudioCompressorsChange(Sender: TObject);
    procedure cboAudioDevicesChange(Sender: TObject);
    procedure cboAudioFormatsChange(Sender: TObject);
    procedure cboAudioInputsChange(Sender: TObject);
    procedure cboVideoCompressorsChange(Sender: TObject);
    procedure cboVideoDevicesChange(Sender: TObject);
    procedure cboVideoInputsChange(Sender: TObject);
    procedure cboVideoSizesChange(Sender: TObject);
    procedure cboVideoSubtypesChange(Sender: TObject);
    procedure chk1stAutoSizeClick(Sender: TObject);
    procedure chk1stEmbeddedClick(Sender: TObject);
    procedure chk1stFullScreenClick(Sender: TObject);
    procedure chk1stKeepAspectRatioClick(Sender: TObject);
    procedure chk1stMouseMovesWindowClick(Sender: TObject);
    procedure chk1stStayOnTopClick(Sender: TObject);
    procedure chk1stUseVideoPortClick(Sender: TObject);
    procedure chk1stVideoWindowActiveClick(Sender: TObject);
    procedure chk2ndAutoSizeClick(Sender: TObject);
    procedure chk2ndEmbeddedClick(Sender: TObject);
    procedure chk2ndFullScreenClick(Sender: TObject);
    procedure chk2ndKeepAspectRatioClick(Sender: TObject);
    procedure chk2ndMouseMovesWindowClick(Sender: TObject);
    procedure chk2ndStayOnTopClick(Sender: TObject);
    procedure chk2ndUseVideoPortClick(Sender: TObject);
    procedure chk2ndVideoWindowActiveClick(Sender: TObject);
    procedure chkRecordingCanPauseClick(Sender: TObject);
    procedure chkBorderClick(Sender: TObject);
    procedure chkFlipHorizontalClick(Sender: TObject);
    procedure chkFlipVerticalClick(Sender: TObject);
    procedure chkGreyScaleClick(Sender: TObject);
    procedure chkInvertColorsClick(Sender: TObject);
    procedure chkOpenDMLClick(Sender: TObject);
    procedure chkPlayerAudioRenderingClick(Sender: TObject);
    procedure chkPreallocFileClick(Sender: TObject);
    procedure chkReduceDVFrameRateClick(Sender: TObject);
    procedure chkRenderAudioDeviceClick(Sender: TObject);
    procedure chkShapeOverlayEnabledClick(Sender: TObject);
    procedure chkStretchPreferredVideoSizeClick(Sender: TObject);
    procedure chkTextOverlayEnabledClick(Sender: TObject);
    procedure chkTextOverlayTransparentClick(Sender: TObject);
    procedure chkTransparencyClick(Sender: TObject);
    procedure chkUseThisFileNameClick(Sender: TObject);
    procedure edtAVIAutoFilePrefixChange(Sender: TObject);
    procedure edtBurstCountChange(Sender: TObject);
    procedure edtBurstIntervalChange(Sender: TObject);
    procedure edtPreallocSizeChange(Sender: TObject);
    procedure edtShapeOverlayHeightChange(Sender: TObject);
    procedure edtShapeOverlayLeftChange(Sender: TObject);
    procedure edtShapeOverlayTopChange(Sender: TObject);
    procedure edtShapeOverlayWidthChange(Sender: TObject);
    procedure edtStoragePathChange(Sender: TObject);
    procedure edtTextOverlayLeftChange(Sender: TObject);
    procedure edtTextOverlayTopChange(Sender: TObject);
    procedure edtTextOverlayWidthChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mmoTextOverlayStringChange(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure rdg1stDisplayedOnClick(Sender: TObject);
    procedure rdg2ndDisplayedOnClick(Sender: TObject);
    procedure rdgAutoFileNameClick(Sender: TObject);
    procedure rdgCompressModeClick(Sender: TObject);
    procedure rdgCompressTypeClick(Sender: TObject);
    procedure rdgPreferredVideoSizeClick(Sender: TObject);
    procedure rdgTextOverlayAlignClick(Sender: TObject);
    procedure rdgTunerInputTypeClick(Sender: TObject);
    procedure rdgVideoRendererClick(Sender: TObject);
    procedure rgdFrameGrabberClick(Sender: TObject);
    procedure rgdFrameGrabberFormatClick(Sender: TObject);
    procedure SendVCRCommand (Sender: TObject);
    procedure tbrAudioBalanceChange(Sender: TObject);
    procedure tbrBitmapOverlaySizeChange(Sender: TObject);
    procedure tbrBrightnessChange(Sender: TObject);
    procedure tbrCaptureZoomSizeChange(Sender: TObject);
    procedure tbrConstrastChange(Sender: TObject);
    procedure tbrHueChange(Sender: TObject);
    procedure tbrSaturationChange(Sender: TObject);
    procedure updPlayerFastSeekSpeedClick(Sender: TObject; Button: TUDBtnType);
    procedure updPlayerSpeedRatioClick(Sender: TObject; Button: TUDBtnType);
    procedure VideoGrabberDeviceArrivalOrRemoval(Sender: TObject; IsDeviceArrival, IsVideoDevice: Boolean; DeviceName: String; DeviceIndex: Integer);
    procedure VideoGrabberDeviceLost(Sender: TObject);
    procedure VideoGrabberDiskFull(Sender: TObject);
    procedure VideoGrabberMouseDown(Sender: TObject; VideoWindow: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure VideoGrabberMouseMove(Sender: TObject; VideoWindow: Integer; Shift: TShiftState; X, Y: Integer);
    procedure VideoGrabberMouseUp(Sender: TObject; VideoWindow: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure VideoGrabberPlayerEndOfStream(Sender: TObject);
    procedure VideoGrabberPreviewStarted(Sender: TObject);
    procedure VideoGrabberResize(Sender: TObject);
    procedure VideoGrabberResizeVideo(Sender: TObject; SourceWidth, SourceHeight: Integer);
    procedure VideoGrabberTVChannelScanCompleted(Sender: TObject);
    procedure VideoGrabberTVChannelScanStarted(Sender: TObject; MinChannel, MaxChannel: Integer);
    procedure tbrAudioInputLevelChange(Sender: TObject);
    procedure btnCreatePreallocFileNowClick(Sender: TObject);
    procedure chkSetFrequencyOverrideClick(Sender: TObject);
    procedure VideoGrabberDVCommandCompleted(Sender: TObject;
      NewStateValue: Integer; NewStateLabel: String);
    procedure chkEnableFrequencyOverridesClick(Sender: TObject);
    procedure rdgVideoRotationClick(Sender: TObject);
    procedure rdgDeinterlacingClick(Sender: TObject);
    procedure rdgNetworkStreamingClick(Sender: TObject);
    procedure rdgRecordingMethodClick(Sender: TObject);
    procedure edtPublishingPointChange(Sender: TObject);
    procedure edtNetworkPortChange(Sender: TObject);
    procedure edtNetworkMaxUsersChange(Sender: TObject);
    procedure btnShowProfilesListClick(Sender: TObject);
    procedure lsbProfilesClick(Sender: TObject);
    procedure edtProfileIndexChange(Sender: TObject);
    procedure chkCompareRedClick(Sender: TObject);
    procedure chkCompareGreenClick(Sender: TObject);
    procedure chkCompareBlueClick(Sender: TObject);
    procedure chk_GreyScaleClick(Sender: TObject);
    procedure chkReduceVideoNoiseClick(Sender: TObject);
    procedure edtGridChange(Sender: TObject);
    procedure updGlobalGridSensitivityClick(Sender: TObject;
      Button: TUDBtnType);
    procedure btnApplyGridSizeClick(Sender: TObject);
    procedure btnSetCellsSensitivityClick(Sender: TObject);
    procedure btnShowGridDialogClick(Sender: TObject);
    procedure chkMotionDetectionEnabledClick(Sender: TObject);
    procedure btnPlayerOpenStreamingURLClick(Sender: TObject);
    procedure VideoGrabberPlayerBufferingData(Sender: TObject;
      StartingToBuffer: Boolean);
    procedure VideoGrabberAudioDeviceSelected(Sender: TObject);
    procedure VideoGrabberLog(Sender: TObject; LogType: TLogType; Severity,
      InfoMsg: String);
    procedure VideoGrabberVideoDeviceSelected(Sender: TObject);
    procedure VideoGrabberColorKeyChange(Sender: TObject;
      ColorKey: TColor);
    procedure tbrAudioInputBalanceChange(Sender: TObject);
    procedure chkAudioInputMonoClick(Sender: TObject);
    procedure VideoGrabberReinitializing(Sender: TObject);
    procedure VideoGrabberCopyPreallocDataStarted(Sender: TObject;
      SourceFile, DestFile: String);
    procedure VideoGrabberCopyPreallocDataCompleted(Sender: TObject;
      SourceFile, DestFile: String; Success: Boolean);
    procedure VideoGrabberCreatePreallocFileStarted(Sender: TObject;
      FileName: String);
    procedure VideoGrabberCreatePreallocFileCompleted(Sender: TObject;
      FileName: String; Success: Boolean);
    procedure VideoGrabberRecordingCompleted(Sender: TObject;
      FileName: String; Success: Boolean);
    procedure VideoGrabberRecordingStarted(Sender: TObject;
      FileName: String);
    procedure edtASFVideoWidthChange(Sender: TObject);
    procedure edtASFVideoHeightChange(Sender: TObject);
    procedure edtASFVideoBitRateChange(Sender: TObject);
    procedure edtASFVideoMaxKeyFrameSpacingChange(Sender: TObject);
    procedure edtASFVideoQualityChange(Sender: TObject);
    procedure edtASFAudioChannelsChange(Sender: TObject);
    procedure VideoGrabberReencodingStarted(Sender: TObject; SourceFile,
      DestFile: String);
    procedure VideoGrabberReencodingCompleted(Sender: TObject; SourceFile,
      DestFile: String; Success: Boolean);
    procedure btnViewDirectNetworkStreamingClick(Sender: TObject);
    procedure VideoGrabberInactive(Sender: TObject);
    procedure btnSourceVideoClipClick(Sender: TObject);
    procedure btnStartReencodingClick(Sender: TObject);
    procedure btnStopReencodingClick(Sender: TObject);
    procedure btnDurationClick(Sender: TObject);
    procedure VideoGrabberRecordingReadyToStart(Sender: TObject);
    procedure btnStartRecordingControlledClick(Sender: TObject);
    procedure chkRefreshPausedDisplayClick(Sender: TObject);
    procedure VideoGrabberPlayerOpened(Sender: TObject);
    procedure chkPreserveNativeFormatClick(Sender: TObject);
    procedure rdgDVPlaybackSizeClick(Sender: TObject);
    procedure chkSetLogoClick(Sender: TObject);
    procedure VideoGrabberDirectNetworkStreamingHostUrl(Sender: TObject;
      HostUrl, HostName: String; HostPort: Integer);
    procedure btnOpenLastClipPlayedClick(Sender: TObject);
    procedure chkASFFixedFrameRateClick(Sender: TObject);
    procedure cmbASFDeinterlaceModeChange(Sender: TObject);
    procedure cboVideoSourceChange(Sender: TObject);
    procedure chkScreenRecordingWithCursorClick(Sender: TObject);
    procedure chkCroppingEnabledClick(Sender: TObject);
    procedure chkCroppingOutboundsClick(Sender: TObject);
    procedure edtCroppingWidthChange(Sender: TObject);
    procedure edtCroppingHeightChange(Sender: TObject);
    procedure trkCroppingZoomChange(Sender: TObject);
    procedure btnCroppingZoomResetClick(Sender: TObject);
    procedure trkCroppingYChange(Sender: TObject);
    procedure trkCroppingXChange(Sender: TObject);
    procedure tbrVMR9BrightnessChange(Sender: TObject);
    procedure tbrVMR9ContrastChange(Sender: TObject);
    procedure tbrVMR9SaturationChange(Sender: TObject);
    procedure tbrVMR9HueChange(Sender: TObject);
    procedure VideoGrabberGraphBuilt(Sender: TObject);
    procedure vmr9FixRangeClick(Sender: TObject);
    procedure chkChangeCursorClick(Sender: TObject);
    procedure btnSelectFileOrUrlClick(Sender: TObject);
    procedure edtVideoSourceFileOrUrlChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkAudioRecordingClick(Sender: TObject);
    procedure tbrAudioVolumeChange(Sender: TObject);
    procedure chkMuteAudioRenderingClick(Sender: TObject);
    procedure btnRenewRecordingFileClick(Sender: TObject);
    procedure VideoGrabberCopyPreallocDataProgress(Sender: TObject;
      Percent: Integer; Position, Duration: Int64);
    procedure VideoGrabberCreatePreallocFileProgress(Sender: TObject;
      Percent: Integer; Position, Duration: Int64);
    procedure VideoGrabberReencodingProgress(Sender: TObject;
      Percent: Integer; Position, Duration: Int64);
    procedure VideoGrabberTVChannelSelected(Sender: TObject;
      Channel: Integer; Locked: Boolean; DefaultVideoFrequency,
      OverriddenVideoFrequency, TunerVideoFrequency,
      TunerAudioFrequency: Integer);
    procedure VideoGrabberFrameCaptureCompleted(Sender: TObject;
      FrameBitmap: TBitmap; BitmapWidth, BitmapHeight: Integer;
      FrameNumber: Cardinal; FrameTime: Int64; DestType: TFrameCaptureDest;
      FileName: String; Success: Boolean; FrameId: Integer);
    procedure VideoGrabberFrameOverlayUsingDC(Sender: TObject; Dc: HDC;
      FrameNumber: Cardinal; FrameTime: Int64; FrameId: Integer);
    procedure VideoGrabberFrameOverlayUsingDIB(Sender: TObject;
      FrameBitmapHandle: HBITMAP; FrameNumber: Cardinal; FrameTime: Int64;
      FrameId: Integer);
    procedure VideoGrabberFrameOverlayUsingVIDEOHDR(Sender: TObject;
      FrameNumber: Cardinal; FrameTime: Int64; FrameId: Integer;
      const VideoHdr: TVideoHdr);
    procedure VideoGrabberMotionDetected(Sender: TObject;
      GlobalMotionRatio: Double; MaxMotionCellX, MaxMotionCellY: Integer;
      FrameBitmap: TBitmap; FrameNumber: Cardinal; FrameTime: Int64;
      FrameId: Integer; var CaptureFrame: Boolean);
    procedure VideoGrabberMotionNotDetected(Sender: TObject;
      FrameBitmap: TBitmap; FrameNumber: Cardinal; FrameTime: Int64;
      FrameId: Integer; var CaptureFrame: Boolean);
    procedure VideoGrabberFrameProgress(Sender: TObject;
      FrameNumber: Cardinal; FrameTime: Int64; FrameId: Integer);
    procedure VideoGrabberVideoFromBitmapsFormatNeeded(Sender: TObject;
      out BitmapHandle: HBITMAP; out BMPorJPEGFile: String);
    procedure VideoGrabberVideoFromBitmapsNextFrameNeeded(Sender: TObject;
      FirstSample: Boolean; out BitmapHandle: HBITMAP;
      out BMPorJPEGFile: String; out EndOfData: Boolean);
    procedure btnNativeFormatClick(Sender: TObject);
    procedure btnLoadImageOverlayFromFileClick(Sender: TObject);
    procedure chkMultiplexedAutoSwitchClick(Sender: TObject);
    procedure btnOpenClipClick(Sender: TObject);
    procedure btnGetClipDurationClick(Sender: TObject);
    procedure cmbBitmapOverlayTransparentColorChange(Sender: TObject);
    procedure updBitmapOverlayAlphaBendClick(Sender: TObject;
      Button: TUDBtnType);
    procedure chkMultiplexedInputEmulationClick(Sender: TObject);
    procedure chkTriggeredClick(Sender: TObject);
    procedure btnTriggerNowClick(Sender: TObject);
  private
    StartupWidth: Integer;
    StartupHeight: Integer;

    TransparentForm: TForm;
    TransparentPanel: TPanel;
    SnapForm: TForm;
    SnapImage: TImage;

    FreeHandMouseDrawing: array[0..FreeHandMouseMax] of TRect;
    FreeHandMouseDrawingEnabled: boolean;
    iFreeHandMouseDrawing: LongInt;

    SearchBmpFiles: TSearchRec;
    SearchBmpFilesOpened: Boolean;
    SearchBmpPath: String;

    cmbBitmapOverlayTransparentColorItemIndex: LongInt; // intermediary variable used to read the ItemIndex from the OnFrameOverlayUsingDC event
    updBitmapOverlayAlphaBendPosition: LongInt;         // intermediary variable used to read the Position from the OnFrameOverlayUsingDC event

    procedure ShowFormAboveVideo(Form: TForm);
    procedure RefreshVideoDeviceControls;
    procedure RefreshDisplayOptions;
  end;

var
  frmMainForm: TfrmMainForm;
implementation

uses
   miscVideoQuality,
   miscCameraControl,
   miscVideoControl;

{$R *.DFM}

procedure AssignListToComboBox (ComboBox: TComboBox; List: String; Index: integer; MaxCount: Integer = 0);
begin
   ComboBox.Text := '';
   ComboBox.Items.Text := List;
   if ComboBox.Items.Count > 0 then begin
      ComboBox.ItemIndex := Index;
   end;
   if MaxCount > 0 then begin
      while ComboBox.Items.count > MaxCount do begin
         ComboBox.Items.Delete (ComboBox.Items.Count - 1);
      end;
   end;
end;

procedure TfrmMainForm.FormCreate(Sender: TObject);
begin
   FreeHandMouseDrawingEnabled:= False; // used for free-hand mouse drawing
   iFreeHandMouseDrawing:= 0;           // used for free-hand mouse drawing
   SearchBmpFilesOpened := False;       // used for the "video from bitmaps" in the VideoGrabberVideoFromBitmaps_NextFrameNeeded event

   StartupWidth := Width;
   StartupHeight := Height;

   // - controls using global TVideoGrabber properties, e.g. like the VideoDevices list, are updated from the FormCreate event
   // - controls that depend of the current video device are set in the VideoDeviceSelected event
   // - controls that depend of the current audio device are set in the AudioDeviceSelected event

   ///////////////////////// Controls on main form
   edtStoragePath.Text := VideoGrabber.StoragePath;

   ///////////////////////// Video source tab
   AssignListToComboBox (cboVideoSource, VideoGrabber.VideoSources, Integer (VideoGrabber.VideoSource), 4);
   btnAutoRefreshPreview.Checked := VideoGrabber.AutoRefreshPreview;
   cboVideoSource.ItemIndex := Integer (VideoGrabber.VideoSource);
   chkScreenRecordingWithCursor.Checked := VideoGrabber.ScreenRecordingWithCursor;
   chkMultiplexedInputEmulation.Checked := VideoGrabber.MultiplexedInputEmulation;

   ///////////////////////// Audio tab
   chkRenderAudioDevice.Checked := VideoGrabber.AudioDeviceRendering;
   chkMuteAudioRendering.Checked := VideoGrabber.MuteAudioRendering;

   ///////////////////////// RECORDING tab
   rdgRecordingMethod.ItemIndex := Integer (VideoGrabber.RecordingMethod);
   edtPreallocSize.Text := IntToStr (VideoGrabber.PreallocCapFileSizeInMB);
   chkRecordingCanPause.Checked := VideoGrabber.RecordingCanPause;
   chkPreallocFile.Checked := VideoGrabber.PreallocCapFileEnabled;
   chkOpenDML.Checked := VideoGrabber.AVIFormatOpenDML;
   chkPreserveNativeFormat.Checked := VideoGrabber.RecordingInNativeFormat;

   rdgCompressType.ItemIndex := integer (VideoGrabber.CompressionType);
   rdgCompressMode.ItemIndex := integer (VideoGrabber.CompressionMode);
   chkAudioRecording.Checked := VideoGrabber.AudioRecording;
   AssignListToComboBox (cboVideoCompressors, VideoCompressors, VideoGrabber.VideoCompressor);
   AssignListToComboBox (cboAudioCompressors, AudioCompressors, VideoGrabber.AudioCompressor);

   ///////////////////////// network Streaming tab

   rdgNetworkStreaming.ItemIndex := Integer (VideoGrabber.NetworkStreaming);
   edtPublishingPoint.Text := VideoGrabber.ASFMediaServerPublishingPoint;
   edtNetworkPort.Text := IntToStr (VideoGrabber.ASFNetworkPort);
   edtNetworkMaxUsers.Text := IntToStr (VideoGrabber.ASFNetworkMaxUsers);

   edtASFVideoWidth.Text := IntToStr (VideoGrabber.ASFVideoWidth);
   edtASFVideoHeight.Text := IntToStr (VideoGrabber.ASFVideoHeight);
   edtASFVideoBitRate.Text := IntToStr (VideoGrabber.ASFVideoBitRate);
   edtASFVideoMaxKeyFrameSpacing.Text := IntToStr (VideoGrabber.ASFVideoMaxKeyFrameSpacing);
   edtASFVideoQuality.Text := IntToStr (VideoGrabber.ASFVideoQuality);
   edtASFAudioChannels.Text := IntToStr (VideoGrabber.ASFAudioChannels);
   chkASFFixedFrameRate.Checked := VideoGrabber.ASFFixedFrameRate;
   cmbASFDeinterlaceMode.ItemIndex := Integer (VideoGrabber.ASFDeinterlaceMode);

   edtProfileIndex.Text := IntToStr (VideoGrabber.ASFProfile);

   ///////////////////////// Player tab
   updPlayerSpeedRatio.Position := Trunc (VideoGrabber.PlayerSpeedRatio * 1000);
   edtPlayerSpeedRatio.Text := FormatFloat ('0.0', VideoGrabber.PlayerSpeedRatio);

   updPlayerFastSeekSpeed.Position := VideoGrabber.PlayerFastSeekSpeedRatio;
   edtPlayerFastSeekSpeed.Text := IntToStr (VideoGrabber.PlayerFastSeekSpeedRatio);

   btnAutoPlay.Checked := VideoGrabber.AutoStartPlayer;
   chkPlayerAudioRendering.Checked := VideoGrabber.PlayerAudioRendering;
   rdgDVPlaybackSize.ItemIndex := Integer (VideoGrabber.PlayerDVSize);
   chkRefreshPausedDisplay.Checked := VideoGrabber.PlayerRefreshPausedDisplay;

   ///////////////////////// Frame grabber tab
   edtAVIAutoFilePrefix.Text := VideoGrabber.AutoFilePrefix;
   rgdFrameGrabberFormat.ItemIndex := Integer (VideoGrabber.FrameGrabberRGBFormat);
   rgdFrameGrabber.ItemIndex := integer (VideoGrabber.FrameGrabber);
   rdgAutoFileName.ItemIndex := integer (VideoGrabber.AutoFileName);

   ///////////////////////// Frame capture tab
   edtBurstCount.Text := IntToStr (VideoGrabber.BurstCount);
   edtBurstInterval.Text := IntToStr (VideoGrabber.BurstInterval);
   tbrCaptureZoomSize.Position := VideoGrabber.FrameCaptureZoomSize;

   ///////////////////////// Motion detection tab

   chkMotionDetectionEnabled.Checked := Videograbber.MotionDetector_Enabled;
   chkCompareRed.Checked := VideoGrabber.MotionDetector_CompareRed;
   chkCompareGreen.Checked := VideoGrabber.MotionDetector_CompareGreen;
   chkCompareBlue.Checked := VideoGrabber.MotionDetector_CompareBlue;
   chk_GreyScale.Checked := VideoGrabber.MotionDetector_GreyScale;
   chkReduceVideoNoise.Checked := VideoGrabber.MotionDetector_ReduceVideoNoise;
   edtGrid.Text := VideoGrabber.MotionDetector_Grid;
   mmoSensitivityGrid.Text := VideoGrabber.MotionDetector_Get2DTextGrid;
   edtGridColCount.Text := IntToStr (VideoGrabber.MotionDetector_GridXCount);
   edtGridRowCount.Text := IntToStr (VideoGrabber.MotionDetector_GridYCount);
   chkTriggered.Checked := VideoGrabber.MotionDetector_Triggered;

   ///////////////////////// TV Tuner tab
   edtCountryCode.Text := IntToStr (VideoGrabber.TVCountryCode);
   rdgTunerInputType.ItemIndex := Integer (VideoGrabber.TVTunerInputType);
   edtTVChannel.Text := IntToStr (VideoGrabber.TVChannel);
   chkEnableFrequencyOverrides.Checked := VideoGrabber.TVUseFrequencyOverrides;

   ///////////////////////// Overlay tab
   mmoTextOverlayString.Text := VideoGrabber.TextOverlay_String;
   chkTextOverlayEnabled.Checked := VideoGrabber.TextOverlay_Enabled;
   chkTextOverlayTransparent.Checked := VideoGrabber.TextOverlay_Transparent;
   cmbBitmapOverlayTransparentColor.ItemIndex := 0;
   cmbBitmapOverlayTransparentColorItemIndex := 0; // intermediary variable used to read the ItemIndex from the OnFrameOverlayUsingDC event
   updBitmapOverlayAlphaBendPosition := 100;       // intermediary variable used to read the Position from the OnFrameOverlayUsingDC event

   ///////////////////////// Video processing tab
   rdgVideoRotation.ItemIndex := Integer (VideoGrabber.VideoProcessing_Rotation);
   tbrBrightness.Position := - VideoGrabber.VideoProcessing_Brightness;
   tbrConstrast.Position := - VideoGrabber.VideoProcessing_Contrast;
   tbrSaturation.Position := - VideoGrabber.VideoProcessing_Saturation;
   tbrHue.Position := VideoGrabber.VideoProcessing_Hue;

   rdgDeinterlacing.ItemIndex := Integer (VideoGrabber.VideoProcessing_Deinterlacing);
   chkGreyScale.Checked := VideoGrabber.VideoProcessing_GrayScale;
   chkInvertColors.Checked := VideoGrabber.VideoProcessing_InvertColors;
   chkFlipVertical.Checked := VideoGrabber.VideoProcessing_FlipVertical;
   chkFlipHorizontal.Checked := VideoGrabber.VideoProcessing_FlipHorizontal;

   chkCroppingEnabled.Checked := VideoGrabber.Cropping_Enabled;
   chkCroppingOutbounds.Checked := VideoGrabber.Cropping_Outbounds;
   edtCroppingWidth.Text := IntToStr (VideoGrabber.Cropping_Width);
   edtCroppingHeight.Text := IntToStr (VideoGrabber.Cropping_Height);
   trkCroppingZoom.Position := Round (VideoGrabber.Cropping_Zoom * 100);

   // trkCroppingX.Max and trkCroppingY.Max are will be set from the OnResizeVideo event
   trkCroppingY.Position := VideoGrabber.Cropping_Y;
   trkCroppingX.Position := VideoGrabber.Cropping_X;

   ///////////////////////// Display tab
   chkBorder.Checked := VideoGrabber.BorderStyle = bsSingle;
   chkTransparency.Checked := VideoGrabber.ColorKeyEnabled;
   rdgVideoRenderer.ItemIndex := Integer (VideoGrabber.VideoRenderer);
   RefreshDisplayOptions;

   ///////////////////////// reencoding tab
   chkWMVOutput.Checked := VideoGrabber.Reencoding_WMVOutput;
   chkIncludeVideoStream.Checked := VideoGrabber.Reencoding_IncludeVideoStream;
   chkIncludeAudioStream.Checked := VideoGrabber.Reencoding_IncludeAudioStream ;
   chkUseFrameGrabber.Checked := VideoGrabber.Reencoding_UseFrameGrabber;
   chkUseCurrentVideoCompressor.Checked := VideoGrabber.Reencoding_UseVideoCompressor;
   chkUseCurrentAudioCompressor.Checked := VideoGrabber.Reencoding_UseAudioCompressor;
   edtStartTime.Text := IntToStr (VideoGrabber.Reencoding_StartTime);
   edtStopTime.Text := IntToStr (VideoGrabber.Reencoding_StopTime);
   rdgReencodingMethod.ItemIndex := Integer (VideoGrabber.Reencoding_Method);

end;

procedure TfrmMainForm.FormShow(Sender: TObject);
begin
   RefreshVideoDeviceControls;
end;

////////////////////////////////////////////////////////////////////////////////
//                            VIDEO DEVICE TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.VideoGrabberVideoDeviceSelected(Sender: TObject);
begin
   // from this event update the properties that depend of the current video capture device.
   // This event occurs when you assign a new value to the VideoDevice property.

   AssignListToComboBox (cboAnalogVideoStandard, VideoGrabber.AnalogVideoStandards, integer (VideoGrabber.AnalogVideoStandard));
   AssignListToComboBox (cboVideoSizes, VideoGrabber.VideoSizes, VideoGrabber.VideoSize);
   AssignListToComboBox (cboVideoSubtypes, VideoGrabber.VideoSubtypes, VideoGrabber.VideoSubtype);
   AssignListToComboBox (cboVideoInputs, VideoGrabber.VideoInputs, integer (VideoGrabber.VideoInput));

   RefreshVideoDeviceControls;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.cboVideoSourceChange(Sender: TObject);
begin
  case cboVideoSource.ItemIndex of
     0: VideoGrabber.VideoSource := vs_VideoCaptureDevice;
     1: VideoGrabber.VideoSource := vs_ScreenRecording;
     2: VideoGrabber.VideoSource := vs_VideoFileOrURL;
     3: VideoGrabber.VideoSource := vs_JPEGsOrBitmaps;
  end;
end;

procedure TfrmMainForm.cboVideoDevicesChange(Sender: TObject);
begin
   VideoGrabber.VideoDevice := cboVideoDevices.ItemIndex;
   // when selecting another video device, the OnVideoDeviceSelected event occurs.
   // be sure to refresh all your device-dependent controls from this event.
end;

procedure TfrmMainForm.btnStartPreviewClick(Sender: TObject);
begin
   VideoGrabber.StartPreview;
end;

procedure TfrmMainForm.btnStopPreviewClick(Sender: TObject);
begin
   VideoGrabber.StopPreview;
end;

procedure TfrmMainForm.btnAutoRefreshPreviewClick(Sender: TObject);
begin
   VideoGrabber.AutoRefreshPreview := btnAutoRefreshpreview.Checked;
end;

procedure TfrmMainForm.cboVideoInputsChange(Sender: TObject);
begin
   VideoGrabber.VideoInput := cboVideoInputs.ItemIndex;
end;

procedure TfrmMainForm.cboVideoSizesChange(Sender: TObject);
begin
   VideoGrabber.VideoSize := cboVideoSizes.ItemIndex;
end;

procedure TfrmMainForm.cboVideoSubtypesChange(Sender: TObject);
begin
   VideoGrabber.VideoSubtype := cboVideoSubtypes.ItemIndex;
end;

procedure TfrmMainForm.cboAnalogVideoStandardChange(Sender: TObject);
begin
   VideoGrabber.AnalogVideoStandard := cboAnalogVideoStandard.ItemIndex;
end;

procedure TfrmMainForm.chkSetLogoClick(Sender: TObject);
begin
   if ChkSetLogo.Checked then begin
      ImgLogo.Visible := False;
      VideoGrabber.SetLogoFromTImage (ImgLogo);
      VideoGrabber.LogoLayout := lg_Stretched;
      VideoGrabber.LogoDisplayed := True;
   end
   else begin
      VideoGrabber.LogoDisplayed := False;
   end;
end;

procedure TfrmMainForm.btnDeviceDialogClick(Sender: TObject);
begin
   VideoGrabber.ShowDialog (dlg_VideoDevice);
   RefreshVideoDeviceControls;
end;

procedure TfrmMainForm.btnCameraControlDialogClick(Sender: TObject);
begin
   ShowFormAboveVideo (frmCameraControl);
end;

procedure TfrmMainForm.btnVideoQualityDialogClick(Sender: TObject);
begin
   ShowFormAboveVideo (frmVideoQuality);
end;

procedure TfrmMainForm.btnVideoControlDialogClick(Sender: TObject);
begin
   ShowFormAboveVideo (frmVideoControl);
end;

procedure TfrmMainForm.btnStreamDialogClick(Sender: TObject);
begin
   // WARNING: USUALLY, THIS DIALOG ALLOWS TO CHANGE ONLY 1 PARAMETER AT THE SAME TIME
   VideoGrabber.ShowDialog (dlg_StreamConfig);
   VideoGrabberVideoDeviceSelected (Self); // to refresh the controls, if required
end;

procedure TfrmMainForm.rdgPreferredVideoSizeClick(Sender: TObject);
begin
   case rdgPreferredVideoSize.ItemIndex of
      0: VideoGrabber.UseNearestVideoSize (0, 0, chkStretchPreferredVideoSize.Checked); // disables the nearest size feature, uses the device's VideoSize index in the VideoSizes list
      1: VideoGrabber.UseNearestVideoSize ( 88,  60, chkStretchPreferredVideoSize.Checked);
      2: VideoGrabber.UseNearestVideoSize ( 88,  72, chkStretchPreferredVideoSize.Checked);
      3: VideoGrabber.UseNearestVideoSize (180, 120, chkStretchPreferredVideoSize.Checked);
      4: VideoGrabber.UseNearestVideoSize (180, 144, chkStretchPreferredVideoSize.Checked);
      5: VideoGrabber.UseNearestVideoSize (320, 240, chkStretchPreferredVideoSize.Checked);
      6: VideoGrabber.UseNearestVideoSize (352, 288, chkStretchPreferredVideoSize.Checked);
      7: VideoGrabber.UseNearestVideoSize (360, 240, chkStretchPreferredVideoSize.Checked);
      8: VideoGrabber.UseNearestVideoSize (360, 288, chkStretchPreferredVideoSize.Checked);
      9: VideoGrabber.UseNearestVideoSize (640, 480, chkStretchPreferredVideoSize.Checked);
     10: VideoGrabber.UseNearestVideoSize (720, 480, chkStretchPreferredVideoSize.Checked);
     11: VideoGrabber.UseNearestVideoSize (720, 576, chkStretchPreferredVideoSize.Checked);
     12: VideoGrabber.UseNearestVideoSize (768, 576, chkStretchPreferredVideoSize.Checked);
      // you can add your own preferred formats
   end;
   cboVideoSizes.Enabled := rdgPreferredVideoSize.ItemIndex = 0;
end;

procedure TfrmMainForm.chkStretchPreferredVideoSizeClick(Sender: TObject);
begin
   rdgPreferredVideoSizeClick (Self);
end;

procedure TfrmMainForm.btnFrameRateClick(Sender: TObject);
var
   Value: Double;
begin
   Value := StrToFloatDef (edtFrameRate.Text, -1);
   VideoGrabber.FrameRate := Value;

   if VideoGrabber.CurrentState = cs_Preview then begin
      mmoLog.lines.Add ('current frame rate: ' + FormatFloat ('0.00', VideoGrabber.CurrentFrameRate) + ' fps.');
   end;
end;

procedure TfrmMainForm.btnSelectFileOrUrlClick(Sender: TObject);
begin
   dlgOpen.FileName := '*.mpg;*.mpeg;*.avi;*.wav;*.asf;*.wmv;*.vob';
   if dlgOpen.Execute then begin
      edtVideoSourceFileOrUrl.Text := dlgOpen.FileName;
   end;
end;

procedure TfrmMainForm.edtVideoSourceFileOrUrlChange(Sender: TObject);
begin
   VideoGrabber.VideoSource_FileOrUrl := edtVideoSourceFileOrUrl.Text;
end;

procedure TfrmMainForm.chkScreenRecordingWithCursorClick(Sender: TObject);
begin
   VideoGrabber.ScreenRecordingWithCursor := chkScreenRecordingWithCursor.Checked;
end;

procedure TfrmMainForm.chkMultiplexedAutoSwitchClick(Sender: TObject);
begin
   if chkMultiplexedAutoSwitch.Checked then begin
      VideoGrabber.MultiplexedRole := mr_MultiplexedMosaic4;
   end
   else begin
      VideoGrabber.MultiplexedRole := mr_NotMultiplexed;
   end;
end;

procedure TfrmMainForm.chkMultiplexedInputEmulationClick(Sender: TObject);
begin
   VideoGrabber.MultiplexedInputEmulation := chkMultiplexedInputEmulation.Checked;
end;

procedure TfrmMainForm.chkReduceDVFrameRateClick(Sender: TObject);
begin
   VideoGrabber.DVReduceFrameRate := chkReduceDVFrameRate.Checked;
end;

procedure TfrmMainForm.VideoGrabberPreviewStarted(Sender: TObject);
begin
   mmoLog.lines.Add ('');
   mmoLog.lines.Add ('video size: ' + IntToStr (VideoGrabber.VideoWidth) + 'x' + IntToStr (VideoGrabber.VideoHeight));
   mmoLog.lines.Add ('display size: ' + IntToStr (VideoGrabber.Display_VideoWidth) + 'x' + IntToStr (VideoGrabber.Display_VideoHeight));
   mmoLog.lines.Add ('current frame rate: ' + FormatFloat ('0.00', VideoGrabber.CurrentFrameRate) + ' fps.');
   mmoLog.lines.Add ('');
end;

procedure TfrmMainForm.VideoGrabberFrameProgress(Sender: TObject;
  FrameNumber: Cardinal; FrameTime: Int64; FrameId: Integer);
var
   DVTimeCode: String;
   DVDateTime: String;
begin
   edtFrameCount.Text := 'frame: ' + IntToStr (FrameNumber)
               + ' dropped:' + IntToStr (VideoGrabber.GetFrameInfo (FrameId, fi_DroppedFrameCount))
               + ' time:' + Format ('%.2d:%.2d:%.2d %.2d', [VideoGrabber.GetFrameInfo (FrameId, fi_SampleTime_Hour),
                                                            VideoGrabber.GetFrameInfo (FrameId, fi_SampleTime_Min),
                                                            VideoGrabber.GetFrameInfo (FrameId, fi_SampleTime_Sec),
                                                            VideoGrabber.GetFrameInfo (FrameId, fi_SampleTime_Hs)]);

   if VideoGrabber.GetFrameInfo (FrameId, fi_DVTimeCode_IsAvailable) > 0 then begin // not available if 0
       DVTimeCode := Format ('tc: %.2d:%.2d:%.2d %.2d',
             [VideoGrabber.GetFrameInfo (FrameId, fi_DVTimeCode_Hour),
              VideoGrabber.GetFrameInfo (FrameId, fi_DVTimeCode_Min),
              VideoGrabber.GetFrameInfo (FrameId, fi_DVTimeCode_Sec),
              VideoGrabber.GetFrameInfo (FrameId, fi_DVTimeCode_Ff)]);
   end
   else begin
      DVTimeCode := '';
   end;
   if VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_IsAvailable) > 0 then begin // not available if 0
       DVDateTime := Format ('dv date: %.2d/%.2d/%.2d %.2d:%.2d:%.2d',
              [VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_Day),
               VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_Month),
               VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_Year),
               VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_Hour),
               VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_Min),
               VideoGrabber.GetFrameInfo (FrameId, fi_DVDateTime_Sec)]);
   end
   else begin
      DVDateTime := '';
   end;
   edtDVDateTime.Text := DVTimeCode + ' ' + DVDateTime;

end;

////////////////////////////////////////////////////////////////////////////////
//                           AUDIO TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.VideoGrabberAudioDeviceSelected(Sender: TObject);
begin
   // from this event set the parameters that change when the current audio capture device change
   cboAudioDevices.ItemIndex := VideoGrabber.AudioDevice; // be sure the listbox index matches the current index value

   AssignListToComboBox (cboAudioFormats, VideoGrabber.AudioFormats, integer (VideoGrabber.AudioFormat));
   AssignListToComboBox (cboAudioInputs, VideoGrabber.AudioInputs, integer (VideoGrabber.AudioInput));
   tbrAudioInputLevel.Position := VideoGrabber.AudioInputLevel;
   tbrAudioInputBalance.Position := VideoGrabber.AudioInputBalance;
   chkAudioInputMono.Checked := VideoGrabber.AudioInputMono;
end;

procedure TfrmMainForm.chkRenderAudioDeviceClick(Sender: TObject);
begin
   VideoGrabber.AudioDeviceRendering := chkRenderAudioDevice.Checked;
end;

procedure TfrmMainForm.cboAudioDevicesChange(Sender: TObject);
begin
   VideoGrabber.AudioDevice := cboAudioDevices.ItemIndex;
end;

procedure TfrmMainForm.cboAudioInputsChange(Sender: TObject);
begin
   VideoGrabber.AudioInput := cboAudioInputs.ItemIndex;
end;

procedure TfrmMainForm.tbrAudioInputLevelChange(Sender: TObject);
begin
   VideoGrabber.AudioInputLevel := tbrAudioInputLevel.Position;
end;

procedure TfrmMainForm.tbrAudioInputBalanceChange(Sender: TObject);
begin
   VideoGrabber.AudioInputBalance := tbrAudioInputBalance.Position;
end;

procedure TfrmMainForm.chkAudioInputMonoClick(Sender: TObject);
begin
   VideoGrabber.AudioInputMono := chkAudioInputMono.Checked;
end;

procedure TfrmMainForm.tbrAudioVolumeChange(Sender: TObject);
begin
   VideoGrabber.AudioVolume := tbrAudioVolume.Position;
end;

procedure TfrmMainForm.tbrAudioBalanceChange(Sender: TObject);
begin
   VideoGrabber.AudioBalance := tbrAudioBalance.Position;
end;

procedure TfrmMainForm.chkMuteAudioRenderingClick(Sender: TObject);
begin
   VideoGrabber.MuteAudioRendering := chkMuteAudioRendering.Checked;
end;

////////////////////////////////////////////////////////////////////////////////
//                             RECORDING TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.btnStartRecordingImmediatelyClick(Sender: TObject);
begin
   if chkAVISaveToThisFile.Checked then begin
      VideoGrabber.RecordingFileName := edtRecordingFileName.Text;
   end
   else begin
      VideoGrabber.RecordingFileName := '';
   end;

   VideoGrabber.HoldRecording := False; // let's start recording as soon as the graph is built.
   VideoGrabber.StartRecording;
end;

procedure TfrmMainForm.btnStartRecordingControlledClick(Sender: TObject);
begin
   if chkAVISaveToThisFile.Checked then begin
      VideoGrabber.RecordingFileName := edtRecordingFileName.Text;
   end
   else begin
      VideoGrabber.RecordingFileName := '';
   end;

   VideoGrabber.HoldRecording := True;
   VideoGrabber.StartRecording;

   // Enabling HoldRecording prevents the recording to start when the recording graph is built.
   // after the OnRecordingReadyToStart event occurs, you can accurately start the
   // recording by invoking ResumeRecording.
end;

procedure TfrmMainForm.btnStopRecordingClick(Sender: TObject);
begin
   VideoGrabber.StopRecording;
end;

procedure TfrmMainForm.btnRenewRecordingFileClick(Sender: TObject);
begin
   if chkAVISaveToThisFile.Checked then begin
      VideoGrabber.RecordingFileName := edtRecordingFileName.Text;
   end
   else begin
      // keyword that indicates TVideoGrabber to generate a new recording file name automatically
      VideoGrabber.RecordingFileName := 'RENEW';
   end;
end;

procedure TfrmMainForm.rdgRecordingMethodClick(Sender: TObject);
begin
   VideoGrabber.RecordingMethod := TRecordingMethod (rdgRecordingMethod.ItemIndex);
   RefreshVideoDeviceControls;
end;

procedure TfrmMainForm.chkRecordingCanPauseClick(Sender: TObject);
begin
   VideoGrabber.RecordingCanPause := chkRecordingCanPause.Checked;
   RefreshVideoDeviceControls;
end;

procedure TfrmMainForm.btnPauseRecordingClick(Sender: TObject);
begin
   VideoGrabber.PauseRecording;
end;

procedure TfrmMainForm.btnResumeRecordingClick(Sender: TObject);
begin
   VideoGrabber.ResumeRecording;
end;

procedure TfrmMainForm.chkOpenDMLClick(Sender: TObject);
begin
   VideoGrabber.AVIFormatOpenDML := chkOpenDML.Checked;
end;

procedure TfrmMainForm.cboAudioFormatsChange(Sender: TObject);
begin
   VideoGrabber.AudioFormat := TAudioFormat (cboAudioFormats.ItemIndex);
end;

procedure TfrmMainForm.chkAudioRecordingClick(Sender: TObject);
begin
   VideoGrabber.AudioRecording := chkAudioRecording.Checked;
   RefreshVideoDeviceControls;
end;

procedure TfrmMainForm.chkPreserveNativeFormatClick(Sender: TObject);
begin
   VideoGrabber.RecordingInNativeFormat := chkPreserveNativeFormat.Checked;
end;

procedure TfrmMainForm.btnNativeFormatClick(Sender: TObject);
begin
   ShowMessage (
      'Means that the recording stream will not be uncompressed.' + #13#10 +
      '' + #13#10 +
      'MUST BE ENABLED:' + #13#10 +
      '- to record hardware-encoded MPEG' + #13#10 +
      '- to record or DV devices in native DV format' + #13#10 +
      '- to record the DV date/time into the video clip and retrieve it during playback' + #13#10 +
      '' + #13#10 +
      'MUST BE DISABLED:' + #13#10 +
      '- to record the text and graphics overlays into the video clip, and retrieve them during playback' + #13#10
   );
end;

procedure TfrmMainForm.chkPreallocFileClick(Sender: TObject);
begin
   VideoGrabber.PreallocCapFileEnabled := chkPreallocFile.Checked;
end;

procedure TfrmMainForm.btnCreatePreallocFileNowClick(Sender: TObject);
begin
   VideoGrabber.CreatePreallocCapFile;
end;

procedure TfrmMainForm.edtPreallocSizeChange(Sender: TObject);
begin
   VideoGrabber.PreallocCapFileSizeInMB := StrToIntDef (edtPreallocSize.Text, 100);
end;

procedure TfrmMainForm.cboVideoCompressorsChange(Sender: TObject);
begin
   VideoGrabber.VideoCompressor := cboVideoCompressors.ItemIndex;
end;

procedure TfrmMainForm.cboAudioCompressorsChange(Sender: TObject);
begin
   VideoGrabber.AudioCompressor := cboAudioCompressors.ItemIndex;
end;

procedure TfrmMainForm.btnVideoCompressorSettingsClick(Sender: TObject);
begin
   VideoGrabber.ShowDialog (dlg_VideoCompressor);
end;

procedure TfrmMainForm.btnAudioCompressorSettingsClick(Sender: TObject);
begin
   VideoGrabber.ShowDialog (dlg_AudioCompressor);
end;

procedure TfrmMainForm.rdgCompressModeClick(Sender: TObject);
begin
   VideoGrabber.CompressionMode := TCompressionMode (rdgCompressMode.ItemIndex);
   RefreshVideoDeviceControls;
end;

procedure TfrmMainForm.rdgCompressTypeClick(Sender: TObject);
begin
   VideoGrabber.CompressionType := TCompressionType (rdgCompressType.ItemIndex);
end;

procedure TfrmMainForm.VideoGrabberRecordingReadyToStart(Sender: TObject);
begin
   if MessageDlg ('Ready to start recording!', mtInformation, [MbOk, MbCancel], 0) = MrOk then begin
      VideoGrabber.ResumeRecording;
   end
   else begin
      VideoGrabber.StopRecording;
   end;
end;

procedure TfrmMainForm.VideoGrabberRecordingStarted(Sender: TObject;
  FileName: String);
begin
   mmoLog.lines.Add ('recording to ' + FileName + ':');
   mmoLog.lines.Add (IntToStr (VideoGrabber.RecordingWidth) + 'x' + IntToStr (VideoGrabber.RecordingHeight));
   mmoLog.lines.Add ('current frame rate: ' + FormatFloat ('0.0', VideoGrabber.CurrentFrameRate) + ' fps.');
   btnRenewRecordingFile.Enabled := True;
end;

procedure TfrmMainForm.VideoGrabberReencodingProgress(Sender: TObject;
  Percent: Integer; Position, Duration: Int64);
begin
   mmoLog.Lines.Add (IntToStr (PerCent) + '% completed...');
end;

procedure TfrmMainForm.VideoGrabberRecordingCompleted(Sender: TObject;
  FileName: String; Success: Boolean);
begin
   if Success then begin
      mmoLog.Lines.Add (FileName + ' successfully created.');
   end
   else begin
      mmoLog.Lines.Add ('recording failed.');
   end;
   btnRenewRecordingFile.Enabled := False;
end;

procedure TfrmMainForm.VideoGrabberReencodingStarted(Sender: TObject;
  SourceFile, DestFile: String);
begin
   mmoLog.lines.Add ('reencoding ' + SourceFile + ' to ' + DestFile + '...');
end;


procedure TfrmMainForm.VideoGrabberReencodingCompleted(Sender: TObject;
  SourceFile, DestFile: String; Success: Boolean);
begin
   if Success then begin
      mmoLog.Lines.Add (SourceFile + ' successfully reencoded to ' + DestFile);
   end
   else begin
      mmoLog.Lines.Add ('Failed to reencode ' + SourceFile + ' to ' + DestFile);
   end;
end;

procedure TfrmMainForm.VideoGrabberCopyPreallocDataStarted(Sender: TObject;
  SourceFile, DestFile: String);
begin
   mmoLog.Lines.Add ('copying data from ' + SourceFile + ' to ' + DestFile + '...');
end;

procedure TfrmMainForm.VideoGrabberCopyPreallocDataProgress(
  Sender: TObject; Percent: Integer; Position, Duration: Int64);
begin
   mmoLog.Lines.Add ('copying data: ' + IntToStr (Percent) + '% completed.');
end;

procedure TfrmMainForm.VideoGrabberCopyPreallocDataCompleted(
  Sender: TObject; SourceFile, DestFile: String; Success: Boolean);
begin
   if Success then begin
      mmoLog.Lines.Add (SourceFile + ' successfully copied to ' + DestFile + '.');
   end
   else begin
      mmoLog.Lines.Add ('ERROR: Failed to copy ' + SourceFile + ' to ' + DestFile + '!');
   end;
end;

procedure TfrmMainForm.VideoGrabberCreatePreallocFileStarted(
  Sender: TObject; FileName: String);
begin
   mmoLog.Lines.Add ('preallocating file ' + FileName + '...');
end;

procedure TfrmMainForm.VideoGrabberCreatePreallocFileProgress(
  Sender: TObject; Percent: Integer; Position, Duration: Int64);
begin
   mmoLog.Lines.Add (IntToStr (PerCent) + '% of preallocated file completed');
end;

procedure TfrmMainForm.VideoGrabberCreatePreallocFileCompleted(
  Sender: TObject; FileName: String; Success: Boolean);
begin
   if Success then begin
      mmoLog.Lines.Add ('preallocated file ' + FileName + ' successfully created.');
   end
   else begin
      mmoLog.Lines.Add ('ERROR: Failed to preallocate ' + FileName);
   end;
end;

////////////////////////////////////////////////////////////////////////////////
//                             FRAME GRABBER TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.rgdFrameGrabberClick(Sender: TObject);
begin
   VideoGrabber.FrameGrabber := TFrameGrabber (rgdFrameGrabber.ItemIndex);
   RefreshVideoDeviceControls;
end;

procedure TfrmMainForm.rgdFrameGrabberFormatClick(Sender: TObject);
begin
   VideoGrabber.FrameGrabberRGBFormat := TFrameGrabberRGBFormat (rgdFrameGrabberFormat.ItemIndex);
end;

procedure TfrmMainForm.rdgAutoFileNameClick(Sender: TObject);
begin
   VideoGrabber.AutoFileName := TAutoFileName (rdgAutoFileName.ItemIndex);
end;

procedure TfrmMainForm.edtAVIAutoFilePrefixChange(Sender: TObject);
begin
   VideoGrabber.AutoFilePrefix := edtAVIAutoFilePrefix.Text;
end;

procedure TfrmMainForm.btnOneShotTBitmapClick(Sender: TObject);
begin
   VideoGrabber.CaptureFrameTo (fc_TBitmap, '');
   // note 1: passing an empty file name let TVideoGrabber generate it automatically in the StoragePath directory
   // note 2: using CaptureFrameSyncTo instead of CaptureFrameTo waits for frame capture completion and returns true upon success
end;

procedure TfrmMainForm.btnOneShotBMPFileClick(Sender: TObject);
begin
   if chkUseThisFileName.Checked then begin
      VideoGrabber.CaptureFrameTo (fc_BmpFile, edtUseThisFileName.Text);
   end
   else begin
      VideoGrabber.CaptureFrameTo (fc_BmpFile, '');
   end;
   // note 1: passing an empty file name let TVideoGrabber generate it automatically in the StoragePath directory
   // note 2: using CaptureFrameSyncTo instead of CaptureFrameTo waits for frame capture completion and returns true upon success
end;

procedure TfrmMainForm.btnOneShotJPEGFileClick(Sender: TObject);
begin
   if chkUseThisFileName.Checked then begin
      VideoGrabber.CaptureFrameTo (fc_JpegFile, edtUseThisFileName.Text);
   end
   else begin
      VideoGrabber.CaptureFrameTo (fc_JpegFile, '');
   end;
   // note 1: passing an empty file name let TVideoGrabber generate it automatically in the StoragePath directory
   // note 2: using CaptureFrameSyncTo instead of CaptureFrameTo waits for frame capture completion and returns true upon success
end;

procedure TfrmMainForm.chkUseThisFileNameClick(Sender: TObject);
begin
   edtUseThisFileName.Enabled := chkUseThisFileName.Checked;
end;

procedure TfrmMainForm.btnBurstModeTBitmapClick(Sender: TObject);
begin
   VideoGrabber.BurstType := fc_TBitmap;
   VideoGrabber.BurstMode := True;
   // The frame capture starts when BurstMode is set to True.
   // If BurstCount = 0 the frame capture won't stop.
   // Captured frames will be returned by the OnFrameCaptureCompleted event.
end;

procedure TfrmMainForm.btnBurstModeBMPFileClick(Sender: TObject);
begin
   VideoGrabber.BurstType := fc_BmpFile;
   VideoGrabber.BurstMode := True;
   // The frame capture starts when BurstMode is set to True.
   // If BurstCount = 0 the frame capture won't stop.
   // BMP file names will be generated automatically according to AutoFileName
   // and AutoFilePrefix. They will be returned by the OnFrameCaptureCompleted event.
end;

procedure TfrmMainForm.btnBurstModeJPEGFileClick(Sender: TObject);
begin
   VideoGrabber.BurstType := fc_JpegFile;
   VideoGrabber.BurstMode := True;
   // The frame capture starts when BurstMode is set to True.
   // If BurstCount = 0 the frame capture won't stop.
   // JPEG file names will be generated automatically according to AutoFileName
   // and AutoFilePrefix. They will be returned by the OnFrameCaptureCompleted event.
end;

procedure TfrmMainForm.btnBurstModeStopClick(Sender: TObject);
begin
   VideoGrabber.BurstMode := False;
end;

procedure TfrmMainForm.edtBurstCountChange(Sender: TObject);
begin
   VideoGrabber.BurstCount := StrToIntDef (edtBurstCount.Text, 1);
end;

procedure TfrmMainForm.edtBurstIntervalChange(Sender: TObject);
begin
   VideoGrabber.BurstInterval := StrToIntDef (edtBurstInterval.Text, 1);
end;

procedure TfrmMainForm.tbrCaptureZoomSizeChange(Sender: TObject);
begin
   VideoGrabber.FrameCaptureZoomSize := tbrCaptureZoomSize.Position;
   edtCaptureZoomSize.Text := IntToStr (tbrCaptureZoomSize.Position) + '%';
end;

procedure TfrmMainForm.btnResetCaptureZoomSizeClick(Sender: TObject);
begin
   tbrCaptureZoomSize.Position := 100;
end;

procedure TfrmMainForm.VideoGrabberFrameCaptureCompleted(Sender: TObject;
  FrameBitmap: TBitmap; BitmapWidth, BitmapHeight: Integer;
  FrameNumber: Cardinal; FrameTime: Int64; DestType: TFrameCaptureDest;
  FileName: String; Success: Boolean; FrameId: Integer);
var
   DestForm: TForm;
   DestImage: TImage;
begin
   if Success then begin
      mmoFrameCaptureLog.Lines.Add ('frame #' + IntToStr (FrameNumber) + ' captured');
   end;
   Case DestType of
      // ______ bmp or jpeg file
      fc_BmpFile, fc_JpegFile: begin
         if Success then begin
             mmoFrameCaptureLog.Lines.Add (FileName);
          end
          else begin
             mmoFrameCaptureLog.Lines.Add ('error: failed to create ' + FileName);
          end;
       end;

      // ______ memory bitmap
      fc_TBitmap: begin
         if (not VideoGrabber.BurstMode) or (VideoGrabber.BurstMode and (VideoGrabber.BurstCount = 0)) then begin // reuse the same form
            if not assigned (SnapForm) then begin
               Application.CreateForm (TForm, SnapForm);
               SnapForm.Position := poDefault;
               SnapForm.Formstyle := fsStayOnTop;
            end;
            if assigned (SnapImage) then begin
               SnapImage.Free;
            end;
            SnapImage := TImage.Create (SnapForm);
            DestForm := SnapForm;
            DestImage := SnapImage;
         end
         else begin // create a form for each image
            Application.CreateForm (TForm, DestForm);
            DestForm.Position := poDefault;
            DestForm.Formstyle := fsStayOnTop;
            DestImage := TImage.Create (DestForm);
            DestImage.Parent := DestForm;
         end;

         DestForm.ClientWidth := BitmapWidth;
         DestForm.ClientHeight := BitmapHeight;
         DestImage.AutoSize := true;

         DestImage.Picture.Bitmap.Assign (FrameBitmap);
         // REPLACING THE STATEMENT ABOVE BY THE 2 STATEMENTS BELOW IS FASTER (AVOIDS BITMAP COPY),
         // DestImage.Picture.Bitmap.Handle := FrameBitmap.Handle;
         // FrameBitmap.ReleaseHandle;

         DestImage.Parent := DestForm;

         if not DestForm.Visible then begin
            DestForm.Show;
         end;
      end;
    end;
end;

////////////////////////////////////////////////////////////////////////////////
//                             PLAYER TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.btnPlayerOpenFileClick(Sender: TObject);
begin
   dlgOpen.FileName := '*.mpg;*.mpeg;*.avi;*.wav;*.asf;*.wmv;*.vob';
   if dlgOpen.Execute then begin
      edtPlayerClip.Text :=dlgOpen.FileName;
   end;
end;

procedure TfrmMainForm.btnPlayerOpenStreamingURLClick(Sender: TObject);
begin
   edtPlayerClip.Text := 'mms://www.datastead.com/demo/demo.wmv';
end;

procedure TfrmMainForm.btnOpenLastClipRecordedClick(Sender: TObject);
begin
   if VideoGrabber.Last_Recording_FileName <> '' then begin
      VideoGrabber.PlayerFileName := VideoGrabber.Last_Recording_FileName;
      VideoGrabber.OpenPlayer;
   end;
end;

procedure TfrmMainForm.btnOpenLastClipPlayedClick(Sender: TObject);
begin
   if VideoGrabber.Last_Clip_Played <> '' then begin
      VideoGrabber.PlayerFileName := VideoGrabber.Last_Clip_Played;
      VideoGrabber.OpenPlayer;
   end;
end;

procedure TfrmMainForm.btnGetClipDurationClick(Sender: TObject);
var
   Duration: int64;
   FrameCount: int64;
begin
    if VideoGrabber.AVIDuration (edtPlayerClip.Text, Duration, FrameCount) then begin
       mmoLog.Lines.Add ('Duration: ' + IntToStr (Duration));
       mmoLog.Lines.Add ('Frame count: ' + IntToStr (FrameCount));
    end
    else begin
       mmoLog.Lines.Add ('failed to get info for this clip');
    end;
end;

procedure TfrmMainForm.btnOpenClipClick(Sender: TObject);
begin
   VideoGrabber.PlayerFileName := edtPlayerClip.Text;
   VideoGrabber.OpenPlayer;
end;

procedure TfrmMainForm.btnPlayerCloseClipClick(Sender: TObject);
begin
   VideoGrabber.ClosePlayer;
end;

procedure TfrmMainForm.btnPlayerPauseClick(Sender: TObject);
begin
   VideoGrabber.PausePlayer;
end;

procedure TfrmMainForm.btnPlayerStopClick(Sender: TObject);
begin
   VideoGrabber.StopPlayer;
end;

procedure TfrmMainForm.btnPlayerStartPlayingClick(Sender: TObject);
begin
   VideoGrabber.RunPlayer;
end;

procedure TfrmMainForm.btnPlayerBackwardsClick(Sender: TObject);
begin
   VideoGrabber.RunPlayerBackwards;
end;

procedure TfrmMainForm.btnPlayerRewindClick(Sender: TObject);
begin
   VideoGrabber.RewindPlayer;
end;

procedure TfrmMainForm.btnPlayerFastForwardClick(Sender: TObject);
begin
   VideoGrabber.FastForwardPlayer;
end;

procedure TfrmMainForm.btnAutoPlayClick(Sender: TObject);
begin
   VideoGrabber.AutoStartPlayer := btnAutoPlay.Checked;
end;

procedure TfrmMainForm.chkPlayerAudioRenderingClick(Sender: TObject);
begin
   VideoGrabber.PlayerAudioRendering := chkPlayerAudioRendering.Checked;
end;

procedure TfrmMainForm.rdgDVPlaybackSizeClick(Sender: TObject);
begin
   VideoGrabber.PlayerDVSize := TDVSize (rdgDVPlaybackSize.ItemIndex);
end;

procedure TfrmMainForm.chkRefreshPausedDisplayClick(Sender: TObject);
begin
   VideoGrabber.PlayerRefreshPausedDisplay := chkRefreshPausedDisplay.Checked;
end;

procedure TfrmMainForm.updPlayerSpeedRatioClick(Sender: TObject; Button: TUDBtnType);
begin
   VideoGrabber.PlayerSpeedRatio := updPlayerSpeedRatio.Position / 1000;
   edtPlayerSpeedRatio.Text := FormatFloat ('0.0', VideoGrabber.PlayerSpeedRatio);
end;

procedure TfrmMainForm.updPlayerFastSeekSpeedClick(Sender: TObject; Button: TUDBtnType);
begin
   VideoGrabber.PlayerFastSeekSpeedRatio := updPlayerFastSeekSpeed.Position;
   edtPlayerFastSeekSpeed.Text := IntToStr (VideoGrabber.PlayerFastSeekSpeedRatio);
end;

procedure TfrmMainForm.VideoGrabberPlayerOpened(Sender: TObject);
begin
   mmoLog.Lines.Add ('');
   mmoLog.Lines.Add ('playing ' + VideoGrabber.PlayerFileName);
   if VideoGrabber.IsPlayerAudioStreamAvailable = ts_True then begin
      mmoLog.Lines.Add ('this video clip has an audio stream');
   end
   else if VideoGrabber.IsPlayerAudioStreamAvailable = ts_False then begin
      mmoLog.Lines.Add ('this video clip does not have audio');
   end;
   mmoLog.Lines.Add ('');
   mmoLog.Lines.Add ('video codec: ' + VideoGrabber.PlayerVideoCodec);
   mmoLog.Lines.Add ('audio codec: ' + VideoGrabber.PlayerAudioCodec);
   mmoLog.Lines.Add ('');
   mmoLog.Lines.Add ('Duration: ' + FormatFloat ('0.00', VideoGrabber.PlayerDuration / 10000000));
   mmoLog.Lines.Add ('Frame count: ' + inttostr (VideoGrabber.PlayerFrameCount));
   mmoLog.Lines.Add ('Frame rate: ' + FormatFloat ('0.00', VideoGrabber.PlayerFrameRate));
   mmoLog.lines.Add ('size:' + IntToStr (VideoGrabber.VideoWidth) + 'x' + IntToStr (VideoGrabber.VideoHeight));
end;

procedure TfrmMainForm.VideoGrabberPlayerBufferingData(Sender: TObject;
  StartingToBuffer: Boolean);
begin
   if StartingToBuffer then begin
      mmoLog.Lines.Add ('buffering data...');
   end
   else begin
      mmoLog.Lines.Add ('buffering completed.');
   end;
end;

procedure TfrmMainForm.VideoGrabberPlayerEndOfStream(Sender: TObject);
begin
   mmoLog.Lines.Add ('end of stream.');
end;

////////////////////////////////////////////////////////////////////////////////
//                           NETWORK STREAMING TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.btnViewDirectNetworkStreamingClick(Sender: TObject);
begin
   if VideoGrabber.StreamingURL <> '' then begin
      ShellExecute(0, 'open', PChar(VideoGrabber.StreamingURL), '', '', SW_SHOW);
   end;
end;

procedure TfrmMainForm.rdgNetworkStreamingClick(Sender: TObject);
begin
   VideoGrabber.NetworkStreaming := TNetworkStreaming (rdgNetworkStreaming.ItemIndex);
   btnViewDirectNetworkStreaming.Enabled := VideoGrabber.NetworkStreaming = ns_ASFDirectNetworkStreaming;
end;

procedure TfrmMainForm.edtNetworkPortChange(Sender: TObject);
begin
   VideoGrabber.ASFNetworkPort := StrToIntDef (edtNetworkPort.Text, 0);
end;

procedure TfrmMainForm.edtNetworkMaxUsersChange(Sender: TObject);
begin
   VideoGrabber.ASFNetworkMaxUsers := StrToIntDef (edtNetworkMaxUsers.Text, 0);
end;

procedure TfrmMainForm.edtPublishingPointChange(Sender: TObject);
begin
   VideoGrabber.ASFMediaServerPublishingPoint := edtPublishingPoint.Text;
end;

procedure TfrmMainForm.btnShowProfilesListClick(Sender: TObject);
begin
   LsbProfiles.Items.Text := VideoGrabber.ASFProfiles;
end;

procedure TfrmMainForm.edtASFVideoWidthChange(Sender: TObject);
begin
   VideoGrabber.ASFVideoWidth := StrToIntDef (edtASFVideoWidth.Text, -1);
end;

procedure TfrmMainForm.edtASFVideoHeightChange(Sender: TObject);
begin
   VideoGrabber.ASFVideoHeight := StrToIntDef (edtASFVideoHeight.Text, -1);
end;

procedure TfrmMainForm.edtASFVideoBitRateChange(Sender: TObject);
begin
   VideoGrabber.ASFVideoBitRate := StrToIntDef (edtASFVideoBitRate.Text, -1);
end;

procedure TfrmMainForm.edtASFVideoMaxKeyFrameSpacingChange(Sender: TObject);
begin
   VideoGrabber.ASFVideoMaxKeyFrameSpacing := StrToIntDef (edtASFVideoMaxKeyFrameSpacing.Text, -1);
end;

procedure TfrmMainForm.edtASFVideoQualityChange(Sender: TObject);
begin
   VideoGrabber.ASFVideoQuality := StrToIntDef (edtASFVideoQuality.Text, -1);
end;

procedure TfrmMainForm.edtASFAudioChannelsChange(Sender: TObject);
begin
   VideoGrabber.ASFAudioChannels := StrToIntDef (edtASFAudioChannels.Text, -1);
end;

procedure TfrmMainForm.chkASFFixedFrameRateClick(Sender: TObject);
begin
   VideoGrabber.ASFFixedFrameRate := chkASFFixedFrameRate.Checked;
end;

procedure TfrmMainForm.cmbASFDeinterlaceModeChange(Sender: TObject);
begin
   VideoGrabber.ASFDeinterlaceMode := TASFDeinterlaceMode (cmbASFDeinterlaceMode.ItemIndex);
end;

procedure TfrmMainForm.edtProfileIndexChange(Sender: TObject);
begin
   VideoGrabber.ASFProfile := StrToIntDef (edtProfileIndex.Text, -1);
end;

procedure TfrmMainForm.lsbProfilesClick(Sender: TObject);
begin
   if LsbProfiles.Items.Count > 0 then begin
      VideoGrabber.ASFProfile := LsbProfiles.ItemIndex;
      edtProfileIndex.Text := IntToStr (VideoGrabber.ASFProfile);
   end;
end;

procedure TfrmMainForm.VideoGrabberDirectNetworkStreamingHostUrl(
  Sender: TObject; HostUrl, HostName: String; HostPort: Integer);
begin
   mmoLog.Lines.Add ('streaming URL: ' + HostUrl);
   mmoLog.Lines.Add ('streaming host: ' + HostName);
   mmoLog.Lines.Add ('streaming port: ' + IntToStr (HostPort));
   btnViewDirectNetworkStreaming.Enabled := True;
end;

////////////////////////////////////////////////////////////////////////////////
//                            TV TUNER TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.rdgTunerInputTypeClick(Sender: TObject);
begin
   VideoGrabber.TVTunerInputType := TTunerInputType (rdgTunerInputType.ItemIndex);
end;

procedure TfrmMainForm.btnSetCountryCodeClick(Sender: TObject);
var
   CountryCode: Integer;
begin
   CountryCode := StrToIntDef (edtCountryCode.Text, - 1);
   if CountryCode >= 0 then begin
      VideoGrabber.TVCountryCode := CountryCode;
   end;
end;

procedure TfrmMainForm.btnSelectClick(Sender: TObject);
var
   Channel: Integer;
begin
   Channel  := StrToIntDef (edtTVChannel.Text, - 1);
   if Channel <> -1 then begin
      VideoGrabber.TVChannel := Channel;
   end;
end;

procedure TfrmMainForm.chkSetFrequencyOverrideClick(Sender: TObject);
var
   Channel: Integer;
   Frequency: Integer;
begin
   Channel  := StrToIntDef (edtTVChannel.Text, - 1);
   Frequency := StrToIntDef (edtChannelFrequency.Text, - 1);
   if (Channel <> -1) and (Frequency <> -1) then begin
      VideoGrabber.TVSetChannelFrequencyOverride (Channel, Frequency);
   end;
end;

procedure TfrmMainForm.btnDeleteFrequencyOverrideClick(Sender: TObject);
var
   Channel: Integer;
begin
   Channel  := StrToIntDef (edtTVChannel.Text, - 1);
   if Channel <> -1 then begin
      VideoGrabber.TVSetChannelFrequencyOverride (Channel, -1);
   end;
end;

procedure TfrmMainForm.chkEnableFrequencyOverridesClick(Sender: TObject);
begin
   VideoGrabber.TVUseFrequencyOverrides := chkEnableFrequencyOverrides.Checked;
end;

procedure TfrmMainForm.btnStartScanClick(Sender: TObject);
begin
   VideoGrabber.TVStartAutoScan;
end;

procedure TfrmMainForm.btnStopScanClick(Sender: TObject);
begin
   if VideoGrabber.TVStopAutoScan then begin
      mmoChannelLog.Lines.add ('stopping autoscan...');
   end;
end;

procedure TfrmMainForm.btnResetAllOverridesClick(Sender: TObject);
begin
   VideoGrabber.TVClearFrequencyOverrides;
end;

procedure TfrmMainForm.VideoGrabberTVChannelSelected(Sender: TObject;
  Channel: Integer; Locked: Boolean; DefaultVideoFrequency,
  OverriddenVideoFrequency, TunerVideoFrequency,
  TunerAudioFrequency: Integer);
var
   sFrequencyInfo: String;
begin
   if Locked then begin
      sFrequencyInfo := IntToStr (Channel) + ': ' + FormatFloat ('0.00', TunerVideoFrequency / 1000000) + ' Mhz (' + IntToStr (TunerVideoFrequency) + ' Hz';
      if OverriddenVideoFrequency <> -1 then begin
         sFrequencyInfo := sFrequencyInfo + ', overridden';
      end;
      sFrequencyInfo := sFrequencyInfo + ')';
      mmoChannelLog.Lines.Add (sFrequencyInfo);
   end
   else begin
      if OverriddenVideoFrequency <> -1 then begin
         mmoChannelLog.Lines.Add (IntToStr (Channel) + '... overridden and not locked');
      end
      else begin
         mmoChannelLog.Lines.Add (IntToStr (Channel) + '...');
      end;
   end;
   edtTVChannel.Text := IntToStr (Channel);
   if OverriddenVideoFrequency <> -1 then begin
      edtChannelFrequency.Text := IntToStr (OverriddenVideoFrequency);
   end
   else begin
      edtChannelFrequency.Text := IntToStr (TunerVideoFrequency);
   end;
end;

procedure TfrmMainForm.VideoGrabberTVChannelScanStarted(Sender: TObject;
  MinChannel, MaxChannel: Integer);
var
   InputType: String;
begin
   Case VideoGrabber.TVTunerInputType of
      TunerInputCable   : InputType := 'cable input';
      TunerInputAntenna : InputType := 'antenna input';
   end;
   mmoChannelLog.Lines.Add ('scanning country code ' + IntToStr (VideoGrabber.TVCountryCode) + ' (' + InputType + ') from channel ' + IntToStr (MinChannel) + ' to ' + IntToStr (MaxChannel) + '...');
end;

procedure TfrmMainForm.VideoGrabberTVChannelScanCompleted(
  Sender: TObject);
begin
   mmoChannelLog.Lines.Add ('autoscan completed.');
end;

////////////////////////////////////////////////////////////////////////////////
//                            FRAME OVERLAY TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.chkTextOverlayEnabledClick(Sender: TObject);
begin
   VideoGrabber.TextOverlay_String := mmoTextOverlayString.Text;
   VideoGrabber.TextOverlay_Enabled := chkTextOverlayEnabled.Checked;
end;

procedure TfrmMainForm.chkTextOverlayTransparentClick(Sender: TObject);
begin
   VideoGrabber.TextOverlay_Transparent := chkTextOverlayTransparent.Checked;
end;

procedure TfrmMainForm.rdgTextOverlayAlignClick(Sender: TObject);
begin
   VideoGrabber.TextOverlay_Align := TTextOverlayAlign (rdgTextOverlayAlign.ItemIndex);
end;

procedure TfrmMainForm.mmoTextOverlayStringChange(Sender: TObject);
begin
   VideoGrabber.TextOverlay_String := mmoTextOverlayString.Text;
end;

procedure TfrmMainForm.edtTextOverlayLeftChange(Sender: TObject);
begin
   VideoGrabber.TextOverlay_Left := StrToIntDef (edtTextOverlayLeft.Text, 0);
end;

procedure TfrmMainForm.edtTextOverlayTopChange(Sender: TObject);
begin
   VideoGrabber.TextOverlay_Top := StrToIntDef (edtTextOverlayTop.Text, 0);
end;

procedure TfrmMainForm.edtTextOverlayWidthChange(Sender: TObject);
begin
   VideoGrabber.TextOverlay_Right := StrToIntDef (edtTextOverlayWidth.Text, 0);
end;

procedure TfrmMainForm.btnFreeHandEraseClick(Sender: TObject);
begin
   iFreeHandMouseDrawing := 0;
end;

procedure TfrmMainForm.tbrBitmapOverlaySizeChange(Sender: TObject);
begin
   edtBitmapOverlaySize.Text := inttostr (tbrBitmapOverlaySize.Position) + '%';
   // look at the VideoGrabberFrameOverlayUsingDC event's code
end;

procedure TfrmMainForm.btnLoadImageOverlayFromFileClick(Sender: TObject);
var
   Jpg: TJpegImage;
begin
   dlgOpen.FileName := '*.bmp;*.jpg;*.jpeg;*.jpe';
   if dlgOpen.Execute then begin
      if pos ('bmp', lowercase (dlgOpen.FileName)) > 0 then begin
         imgBitmapOverlay.Picture.LoadFromFile (dlgOpen.FileName);
      end
      else begin
         Jpg := TJpegImage.Create;
         Jpg.LoadFromFile (dlgOpen.FileName);
         imgBitmapOverlay.Picture.Bitmap.Canvas.Draw (0, 0, Jpg);
         Jpg.Free;
      end;
   end;
end;

procedure TfrmMainForm.btnBitmapOverlayResetSizeClick(Sender: TObject);
begin
   tbrBitmapOverlaySize.Position := 100;
end;

procedure TfrmMainForm.chkShapeOverlayEnabledClick(Sender: TObject);
begin
   VideoGrabber.ShapeOverlay := shpShapeOverlay;
   VideoGrabber.ShapeOverlayEnabled := chkShapeOverlayEnabled.Checked;
   edtShapeOverlayLeftChange(Self);
   edtShapeOverlayTopChange(Self);
   edtShapeOverlayWidthChange(Self);
   edtShapeOverlayHeightChange(Self);
end;

procedure TfrmMainForm.edtShapeOverlayLeftChange(Sender: TObject);
begin
   shpShapeOverlay.Left := StrToIntDef (edtShapeOverlayLeft.Text, 0);
end;

procedure TfrmMainForm.edtShapeOverlayTopChange(Sender: TObject);
begin
   shpShapeOverlay.Top := StrToIntDef (edtShapeOverlayTop.Text, 0);
end;

procedure TfrmMainForm.edtShapeOverlayWidthChange(Sender: TObject);
begin
   shpShapeOverlay.Width := StrToIntDef (edtShapeOverlayWidth.Text, 0);
end;

procedure TfrmMainForm.edtShapeOverlayHeightChange(Sender: TObject);
begin
   shpShapeOverlay.Height := StrToIntDef (edtShapeOverlayHeight.Text, 0);
end;

procedure TfrmMainForm.updBitmapOverlayAlphaBendClick(Sender: TObject;
  Button: TUDBtnType);
begin
   updBitmapOverlayAlphaBendPosition := updBitmapOverlayAlphaBend.Position;
end;

procedure TfrmMainForm.cmbBitmapOverlayTransparentColorChange(
  Sender: TObject);
begin
   cmbBitmapOverlayTransparentColorItemIndex := cmbBitmapOverlayTransparentColor.ItemIndex;
end;

procedure TfrmMainForm.VideoGrabberFrameOverlayUsingDC(Sender: TObject;
  Dc: HDC; FrameNumber: Cardinal; FrameTime: Int64; FrameId: Integer);
var
   i: integer;
   LeftPos: LongInt;
   TopPos: LongInt;
   BitmapOverlayWidth, BitmapOverlayHeight: LongInt;
   Canvas: TCanvas;
   Transparent: Boolean;
   UseTransparentColor: Boolean;
   TransparentColorValue: TColor;
   AlphaBlend: Boolean;
   AlphaBlendValue: LongInt;
begin
//    From this event you should not perform any actions with the potential to block:
//    1. do not hold a critical section or wait on another thread,
//    2. do not call any GDI or USER32.DLL APIs that might cause a window to move,
//    3. do not invoke component properties that send messages, e.g. do not read the ItemIndex property
//       of a ListBox component. If you need to read a such property, set an intermediary variable when
//       the property changes, and then read the intermediary variable from this event.

   if not assigned (chkBitmapOverlayEnabled) then Exit; // just a security, if the app is closing, this control could have been destroyed when the event occurs

   if chkBitmapOverlayEnabled.Checked then begin

      LeftPos := StrToIntDef (edtBitmapOvlerlayLeft.Text, 0);
      TopPos := StrToIntDef (edtBitmapOvlerlayTop.Text, 0);

      if tbrBitmapOverlaySize.Position = 100 then begin // faster if we do not have to resize the bitmap
         BitmapOverlayWidth := imgBitmapOverlay.Picture.Bitmap.Width;
         BitmapOverlayHeight := imgBitmapOverlay.Picture.Bitmap.Height;
      end
      else begin
         BitmapOverlayWidth  := Round (imgBitmapOverlay.Picture.Bitmap.Width * tbrBitmapOverlaySize.Position / 100);
         BitmapOverlayHeight := Round (imgBitmapOverlay.Picture.Bitmap.Height * tbrBitmapOverlaySize.Position / 100);
      end;

      Transparent := False;
      UseTransparentColor := False;
      TransparentColorValue := 0;

      AlphaBlend := False;
      AlphaBlendValue := 0;

      if chkBitmapOverlayTransparent.Checked then begin
         Transparent := True;
         if chkBitmapOverlayUseTransparentColor.Checked then begin
            UseTransparentColor := True;
            case cmbBitmapOverlayTransparentColorItemIndex of
               0: TransparentColorValue := clYellow;
               1: TransparentColorValue := clRed;
               2: TransparentColorValue := clBlue;
               3: TransparentColorValue := clWhite;
            end;
         end;
      end;

      if chkBitmapOverlayAlphaBlend.Checked then begin
         AlphaBlend := True;
         AlphaBlendValue := updBitmapOverlayAlphaBendPosition;
      end;
      VideoGrabber.DrawBitmapOverFrame (imgBitmapOverlay.Picture.Bitmap, LeftPos, TopPos, BitmapOverlayWidth, BitmapOverlayHeight, Transparent, UseTransparentColor, TransparentColorValue, AlphaBlend, AlphaBlendValue);
   end;

   if iFreeHandMouseDrawing > 0 then begin // see VideoGrabberMouseMove event below
      Canvas := TCanvas.Create;
      Canvas.Handle := Dc;
      Canvas.Pen.Color := clRed;
      for i := 0 to iFreeHandMouseDrawing - 1 do begin
         if FreeHandMouseDrawing[i].Right = 0 then begin // Right is used as boolean to know if it is a MoveTo or a LineTo
            Canvas.MoveTo (FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top);
            Canvas.Pixels[FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top] := clRed;
         end
         else begin
            Canvas.LineTo (FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top);
         end;
      end;
      Canvas.Free;
   end;
end;

procedure TfrmMainForm.VideoGrabberFrameOverlayUsingDIB(Sender: TObject;
  FrameBitmapHandle: HBITMAP; FrameNumber: Cardinal; FrameTime: Int64;
  FrameId: Integer);
var
   DibSection: TDibSection;
   i: integer;
   SkipLine: boolean;
begin
//    From this event you should not perform any actions with the potential to block:
//    1. do not hold a critical section or wait on another thread,
//    2. do not call any GDI or USER32.DLL APIs that might cause a window to move,
//    3. do not invoke component properties that send messages, e.g. do not read the ItemIndex property
//       of a ListBox component. If you need to read a such property, set an intermediary variable when
//       the property changes, and then read the intermediary variable from this event.

   if GetObject (FrameBitmapHandle, sizeof (TDibSection), @DibSection) = 0 then Exit;
   if not assigned (chkLinesOverlayEnabled) then Exit; // just a security, if the app is closing, this control could have been destroyed when the event occurs
   if chkLinesOverlayEnabled.Checked then begin
      SkipLine := false;
      for i := 0 to DibSection.dsBm.bmHeight - 1 do begin
         if SkipLine then begin
            ZeroMemory (Pointer (Integer(DibSection.dsBm.bmBits) + (i * DibSection.dsBm.bmWidthBytes)), DibSection.dsBm.bmWidthBytes);
         end;
         SkipLine := not SkipLine;
      end;
   end;
end;

procedure TfrmMainForm.VideoGrabberFrameOverlayUsingVIDEOHDR(
  Sender: TObject; FrameNumber: Cardinal; FrameTime: Int64;
  FrameId: Integer; const VideoHdr: TVideoHdr);
const
   BLUE = 0;
   GREEN = 1;
   RED = 2;
var
   pBitmapBits: LongWord;
   i, j: LongWord;
   VideoWidth, VideoHeight: LongWord;
   MinVert, MaxVert: LongWord;
   MinHorz, MaxHorz: LongWord;
   Color1Off, Color2Off: LongWord;
   RGBSize: LongWord;
begin
//    From this event you should not perform any actions with the potential to block:
//    1. do not hold a critical section or wait on another thread,
//    2. do not call any GDI or USER32.DLL APIs that might cause a window to move,
//    3. do not invoke component properties that send messages, e.g. do not read the ItemIndex property
//       of a ListBox component. If you need to read a such property, set an intermediary variable when
//       the property changes, and then read the intermediary variable from this event.

   if not assigned (grbColorFiltering) then Exit; // just a security, if the app is closing, this control could have been destroyed when the event occurs
   case grbColorFiltering.ItemIndex of
      1: begin  // RED
         Color1Off := BLUE;
         Color2Off := GREEN;
      end;
      2: begin  // GREEN
         Color1Off := RED;
         Color2Off := BLUE;
      end;
      3: begin  // BLUE
         Color1Off := RED;
         Color2Off := GREEN;
      end;
      else Exit; // "off" or invalid value
   end;

   case VideoGrabber.FrameGrabberCurrentRGBFormat of
      fgf_RGB24: begin
         RGBSize := 3;
      end;
      fgf_RGB32: begin
         RGBSize := 4;
      end;
      else Exit; // we do not support other RGB formats in this example
   end;

   pBitmapBits := LongWord (VideoHdr.lpData); // pointer to the bitmap bits

   VideoWidth := VideoGrabber.VideoWidth; // to avoid invoking the VideoGrabber.VideoWidth function in the loop below
   VideoHeight := VideoGrabber.VideoHeight; // to avoid invoking the VideoGrabber.VideoHeight function in the loop below

   // to get centered vertical bounds within the frame
   MinVert := VideoHeight shr 2; // 2 bits right-shifted = divided by 4
   MaxVert := VideoHeight - MinVert;

   // to get centered horizontal bounds within the frame
   MinHorz := VideoWidth shr 2; // 2 bits right-shifted = divided by 4
   MaxHorz := VideoWidth - MinHorz;


   for j := MinVert to MaxVert do begin
      for i := MinHorz to MaxHorz do begin
        pByte ((pBitmapBits + (j * VideoWidth + i) * RGBSize) + Color1Off)^ := 0;
        pByte ((pBitmapBits + (j * VideoWidth + i) * RGBSize) + Color2Off)^ := 0;
      end;
   end;
end;

procedure TfrmMainForm.VideoGrabberMouseDown(Sender: TObject;
  VideoWindow: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
   if VideoWindow <> -1 then begin // if the video is displayed
      if chkFreeHandEnabled.Checked then begin
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Left := x;
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Top := y;
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Right := 0; // Right is used as boolean to know if it is a MoveTo or a LineTo
         inc (iFreeHandMouseDrawing);
         FreeHandMouseDrawingEnabled := True;
      end;
   end;
end;

procedure TfrmMainForm.VideoGrabberMouseMove(Sender: TObject;
  VideoWindow: Integer; Shift: TShiftState; X, Y: Integer);
begin
   if VideoWindow <> -1 then begin // if the video is displayed
      if FreeHandMouseDrawingEnabled then begin
         if iFreeHandMouseDrawing < FreeHandMouseMax then begin
            FreeHandMouseDrawing[iFreeHandMouseDrawing].Left := x;
            FreeHandMouseDrawing[iFreeHandMouseDrawing].Top := y;
            FreeHandMouseDrawing[iFreeHandMouseDrawing].Right := 1; // Right is used as boolean to know if it is a MoveTo or a LineTo
            inc (iFreeHandMouseDrawing);
         end;
      end;
   end;
end;

procedure TfrmMainForm.VideoGrabberMouseUp(Sender: TObject;
  VideoWindow: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
   FreeHandMouseDrawingEnabled := False;
end;

procedure TfrmMainForm.VideoGrabberResizeVideo(Sender: TObject; SourceWidth, SourceHeight: Integer);
begin
   VideoGrabber.TextOverlay_Right := SourceWidth;
   trkCroppingX.Max := VideoGrabber.Cropping_XMax;
   trkCroppingY.Max := VideoGrabber.Cropping_YMax;
end;

////////////////////////////////////////////////////////////////////////////////
//                           VIDEO PROCESSING TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.rdgVideoRotationClick(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_Rotation := TVideoRotation (rdgVideoRotation.ItemIndex);
end;

procedure TfrmMainForm.rdgDeinterlacingClick(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_Deinterlacing := TVideoDeinterlacing (rdgDeinterlacing.ItemIndex);
end;

procedure TfrmMainForm.tbrBrightnessChange(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_Brightness := - tbrBrightness.Position;
end;

procedure TfrmMainForm.tbrConstrastChange(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_Contrast := - tbrConstrast.Position;
end;

procedure TfrmMainForm.tbrSaturationChange(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_Saturation := - tbrSaturation.Position;
end;

procedure TfrmMainForm.tbrHueChange(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_Hue := tbrHue.Position;
end;

procedure TfrmMainForm.btnResetAllClick(Sender: TObject);
begin
   rdgVideoRotation.ItemIndex := 0;
   rdgDeinterlacing.ItemIndex := 0;
   tbrBrightness.Position := 0;
   tbrConstrast.Position := 0;
   tbrSaturation.Position := 0;
   tbrHue.Position := 0;
   chkGreyScale.Checked := False;
   chkInvertColors.Checked := False;
   chkFlipVertical.Checked := False;
   chkFlipHorizontal.Checked := False;
end;

procedure TfrmMainForm.chkFlipVerticalClick(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_FlipVertical := chkFlipVertical.Checked;
end;

procedure TfrmMainForm.chkFlipHorizontalClick(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_FlipHorizontal := chkFlipHorizontal.Checked;
end;

procedure TfrmMainForm.chkGreyScaleClick(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_GrayScale := chkGreyScale.Checked;
end;

procedure TfrmMainForm.chkInvertColorsClick(Sender: TObject);
begin
   VideoGrabber.VideoProcessing_InvertColors := chkInvertColors.Checked;
end;

procedure TfrmMainForm.VideoGrabberGraphBuilt(Sender: TObject);

   procedure InitVMR9Trackbar (VMR9ImageAdjustment: TVMR9ImageAdjustment; Trackbar: TTrackBar);
   var
      MinValue, MaxValue, StepSize, DefaultValue, CurrentValue: LongInt;
   begin
       Trackbar.Enabled := VideoGrabber.GetVMR9ImageAdjustmentBounds (True, vmr9_Brightness, MinValue, MaxValue, StepSize, DefaultValue, CurrentValue);
       if Trackbar.Enabled then begin
          TrackBar.Min := MinValue;
          TrackBar.Max := MaxValue;
          TrackBar.Frequency := StepSize;
          TrackBar.Position := CurrentValue;
       end;
   end;
begin
   InitVMR9Trackbar (vmr9_Brightness, tbrVMR9Brightness);
   InitVMR9Trackbar (vmr9_Contrast, tbrVMR9Contrast);
   InitVMR9Trackbar (vmr9_Saturation, tbrVMR9Saturation);
   InitVMR9Trackbar (vmr9_Hue, tbrVMR9Hue);

   tbrAudioBalance.Position := VideoGrabber.AudioBalance;
   tbrAudioVolume.Position := VideoGrabber.AudioVolume;
end;

procedure TfrmMainForm.tbrVMR9BrightnessChange(Sender: TObject);
begin
   VideoGrabber.SetVMR9ImageAdjustmentValue (True, vmr9_Brightness, tbrVMR9Brightness.Position, false);
end;

procedure TfrmMainForm.tbrVMR9ContrastChange(Sender: TObject);
begin
   VideoGrabber.SetVMR9ImageAdjustmentValue (True, vmr9_Contrast, tbrVMR9Contrast.Position, vmr9FixRange.Checked);
end;

procedure TfrmMainForm.tbrVMR9SaturationChange(Sender: TObject);
begin
   VideoGrabber.SetVMR9ImageAdjustmentValue (True, vmr9_Saturation, tbrVMR9Saturation.Position, vmr9FixRange.Checked);
end;

procedure TfrmMainForm.tbrVMR9HueChange(Sender: TObject);
begin
   VideoGrabber.SetVMR9ImageAdjustmentValue (True, vmr9_Hue, tbrVMR9Hue.Position, false);
end;

procedure TfrmMainForm.vmr9FixRangeClick(Sender: TObject);
begin
   // fixes a possible problem of constrast and saturation range with some video decoders, passed to the SetVMR9ImageAdjustmentValue function below
end;

procedure TfrmMainForm.chkCroppingEnabledClick(Sender: TObject);
begin
   VideoGrabber.Cropping_Enabled := chkCroppingEnabled.Checked;
end;

procedure TfrmMainForm.chkCroppingOutboundsClick(Sender: TObject);
begin
   VideoGrabber.Cropping_Outbounds := chkCroppingOutbounds.Checked;
end;

procedure TfrmMainForm.edtCroppingWidthChange(Sender: TObject);
begin
   VideoGrabber.Cropping_Width := StrToIntDef (edtCroppingWidth.Text, 0);
end;

procedure TfrmMainForm.edtCroppingHeightChange(Sender: TObject);
begin
   VideoGrabber.Cropping_Height := StrToIntDef (edtCroppingHeight.Text, 0);
end;

procedure TfrmMainForm.trkCroppingZoomChange(Sender: TObject);
begin
   VideoGrabber.Cropping_Zoom := trkCroppingZoom.Position / 100;
end;

procedure TfrmMainForm.btnCroppingZoomResetClick(Sender: TObject);
begin
   trkCroppingZoom.Position := 100;
end;

procedure TfrmMainForm.trkCroppingYChange(Sender: TObject);
begin
   // trkCroppingX.Max and trkCroppingY.Max are set from the OnResizeVideo event
   VideoGrabber.Cropping_Y := trkCroppingY.Position;
end;

procedure TfrmMainForm.trkCroppingXChange(Sender: TObject);
begin
   // trkCroppingX.Max and trkCroppingY.Max are set from the OnResizeVideo event
   VideoGrabber.Cropping_X := trkCroppingX.Position;
end;

////////////////////////////////////////////////////////////////////////////////
//                                DISPLAY TAB
////////////////////////////////////////////////////////////////////////////////

procedure EnableOrDisableGroupBoxControls (GroupBox: TGroupBox; Value: Boolean);
var
   i: integer;
begin
   for i := 0 to GroupBox.ControlCount - 1 do begin
      GroupBox.Controls[i].Enabled := Value;
   end;
end;

procedure TfrmMainForm.RefreshDisplayOptions;
begin
   // this procedure is called each time a setting of this form is changed,
   // to show what features can be used, according to their respective states

   // NOTE: duplicating 2 times all the components of this form for the 2 windows
   // is not very efficient, this has been done only for a better readability.

   chk1stVideoWindowActive.Checked := VideoGrabber.Display_Active;
   chk1stEmbedded.Checked          := VideoGrabber.Display_Embedded;
   chk1stFullScreen.Checked        := VideoGrabber.Display_FullScreen;
   chk1stStayOnTop.Checked         := VideoGrabber.Display_StayOnTop;
   chk1stUseVideoPort.Checked      := VideoGrabber.Display_VideoPortEnabled;
   chk1stMouseMovesWindow.Checked  := VideoGrabber.Display_MouseMovesWindow;
   chk1stAutoSize.Checked          := VideoGrabber.Display_AutoSize;
   chk1stKeepAspectRatio.Checked   := VideoGrabber.Display_KeepAspectRatio;
   rdg1stDisplayedOn.ItemIndex     := VideoGrabber.Display_Monitor;

   EnableOrDisableGroupBoxControls (grbMainVideoWindow, VideoGrabber.Display_Active);

   if VideoGrabber.Display_Active then begin
      chk1stStayOnTop.Enabled         := (not VideoGrabber.Display_Embedded) or VideoGrabber.Display_FullScreen;
      rdg1stDisplayedOn.Enabled       := MonitorsCount > 1;
      chk1stMouseMovesWindow.Enabled  := not VideoGrabber.Display_Embedded;
      rdg1stDisplayedOn.Enabled       := not VideoGrabber.Display_Embedded;
      btnEG1stNewLocation.Enabled     := not VideoGrabber.Display_Embedded;
      btnEG1stNewLocation2.Enabled    := not VideoGrabber.Display_Embedded;
      chk1stUseVideoPort.Enabled      := VideoGrabber.IsVideoPortAvailable;
   end;

   chk2ndVideoWindowActive.Checked := VideoGrabber.DualDisplay_Active;
   chk2ndEmbedded.Checked          := VideoGrabber.DualDisplay_Embedded;
   chk2ndFullScreen.Checked        := VideoGrabber.DualDisplay_FullScreen;
   chk2ndStayOnTop.Checked         := VideoGrabber.DualDisplay_StayOnTop;
   chk2ndUseVideoPort.Checked      := VideoGrabber.DualDisplay_VideoPortEnabled;
   chk2ndMouseMovesWindow.Checked  := VideoGrabber.DualDisplay_MouseMovesWindow;
   chk2ndAutoSize.Checked          := VideoGrabber.DualDisplay_AutoSize;
   chk2ndKeepAspectRatio.Checked   := VideoGrabber.DualDisplay_KeepAspectRatio;
   rdg2ndDisplayedOn.ItemIndex     := VideoGrabber.DualDisplay_Monitor;

   EnableOrDisableGroupBoxControls (grb2ndVideoWindow, VideoGrabber.DualDisplay_Active);

   if VideoGrabber.DualDisplay_Active then begin
      chk2ndStayOnTop.Enabled         := (not VideoGrabber.DualDisplay_Embedded) or VideoGrabber.DualDisplay_FullScreen;
      rdg2ndDisplayedOn.Enabled       := MonitorsCount > 1;
      chk2ndMouseMovesWindow.Enabled  := not VideoGrabber.DualDisplay_Embedded;
      rdg2ndDisplayedOn.Enabled       := not VideoGrabber.DualDisplay_Embedded;
      btnEG2ndNewLocation.Enabled     := not VideoGrabber.DualDisplay_Embedded;
      btnEG2ndNewLocation.Enabled     := not VideoGrabber.DualDisplay_Embedded;
      chk2ndUseVideoPort.Enabled      := VideoGrabber.IsVideoPortAvailable;
   end;
end;

procedure TfrmMainForm.chkChangeCursorClick(Sender: TObject);
begin
   case chkChangeCursor.Checked of
      true  : VideoGrabber.VideoCursor := crCross;
      false : VideoGrabber.VideoCursor := crDefault;
   end;
end;

procedure TfrmMainForm.chkBorderClick(Sender: TObject);
begin
   if chkBorder.Checked then begin
      VideoGrabber.BorderStyle := bsSingle;
   end
   else begin
      VideoGrabber.BorderStyle := bsNone;
   end;
end;

procedure TfrmMainForm.chkTransparencyClick(Sender: TObject);
begin
   // in this sample the transparent window is created in the VideoGrabberColorKeyChange
   // event below when the color key is set
   VideoGrabber.ColorKeyEnabled := chkTransparency.Checked;
end;

procedure TfrmMainForm.rdgVideoRendererClick(Sender: TObject);
begin
   VideoGrabber.VideoRenderer := TVideoRenderer (rdgVideoRenderer.ItemIndex);
end;

procedure TfrmMainForm.chk1stVideoWindowActiveClick(Sender: TObject);
begin
   VideoGrabber.Display_Active := chk1stVideoWindowActive.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stEmbeddedClick(Sender: TObject);
begin
   VideoGrabber.Display_Embedded := chk1stEmbedded.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stAutoSizeClick(Sender: TObject);
begin
   VideoGrabber.Display_AutoSize := chk1stAutoSize.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stKeepAspectRatioClick(Sender: TObject);
begin
   VideoGrabber.Display_KeepAspectRatio := chk1stKeepAspectRatio.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stFullScreenClick(Sender: TObject);
begin
   VideoGrabber.Display_FullScreen := chk1stFullScreen.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stStayOnTopClick(Sender: TObject);
begin
   VideoGrabber.Display_StayOnTop := chk1stStayOnTop.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stUseVideoPortClick(Sender: TObject);
begin
   VideoGrabber.Display_VideoPortEnabled := chk1stUseVideoPort.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.rdg1stDisplayedOnClick(Sender: TObject);
begin
   VideoGrabber.Display_Monitor := rdg1stDisplayedOn.ItemIndex; // 0 or 1
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.btnEG1stNewLocationClick(Sender: TObject);
begin
   VideoGrabber.Display_AutoSize := True;  // the component's video size will be used
   VideoGrabber.Display_Embedded := False; // detach from component
   VideoGrabber.Display_SetLocation (10, 10, 320, 240); // 320 and 240 are not used because of AutoSize above
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.btnEG1stNewLocation2Click(Sender: TObject);
begin
   VideoGrabber.Display_AutoSize := False; // we will specify the size below
   VideoGrabber.Display_Embedded := False; // detach from component
   VideoGrabber.Display_SetLocation (20, 20, 480, 360); // new size: 480 x 360
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk1stMouseMovesWindowClick(Sender: TObject);
begin
   VideoGrabber.Display_MouseMovesWindow := chk1stMouseMovesWindow.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndVideoWindowActiveClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_Active := chk2ndVideoWindowActive.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndEmbeddedClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_Embedded := chk2ndEmbedded.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndFullScreenClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_FullScreen := chk2ndFullScreen.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndAutoSizeClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_AutoSize := chk2ndAutoSize.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndKeepAspectRatioClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_KeepAspectRatio := chk2ndKeepAspectRatio.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndStayOnTopClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_StayOnTop := chk2ndStayOnTop.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndUseVideoPortClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_VideoPortEnabled := chk2ndUseVideoPort.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.chk2ndMouseMovesWindowClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_MouseMovesWindow := chk2ndMouseMovesWindow.Checked;
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.rdg2ndDisplayedOnClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_Monitor := rdg2ndDisplayedOn.ItemIndex; // 0 or 1
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.btnEG2ndNewLocationClick(Sender: TObject);
begin
   VideoGrabber.DualDisplay_AutoSize := True;  // the component's video size will be used
   VideoGrabber.DualDisplay_Embedded := False; // detach from component
   VideoGrabber.DualDisplay_SetLocation (510, 10, 320, 240); // 320 and 240 are not used because of AutoSize above
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.btnEG2ndNewLocation2Click(Sender: TObject);
begin
   VideoGrabber.DualDisplay_AutoSize := False; // we will specify the size below
   VideoGrabber.DualDisplay_Embedded := False; // detach from component
   VideoGrabber.DualDisplay_SetLocation (520, 30, 480, 360); // new size: 480 x 360
   RefreshDisplayOptions;
end;

procedure TfrmMainForm.VideoGrabberColorKeyChange(Sender: TObject;
  ColorKey: TColor);
begin
   if not assigned (TransparentForm) then begin
      Application.CreateForm (TForm, TransparentForm);
      TransparentForm.Width := 300;
      TransparentForm.Height := 100;
      TransparentForm.Position := poScreenCenter;
      TransparentForm.FormStyle := fsStayOnTop;
      TransparentPanel := TPanel.Create (TransparentForm);
      TransparentPanel.Parent := TransparentForm;
      TransparentPanel.BevelInner := bvNone;
      TransparentPanel.BevelOuter := bvNone;
      TransparentPanel.Align := alClient;
      TransparentPanel.Caption := 'transparent window';
      TransparentPanel.Font.Color := clRed;
      TransparentPanel.Font.Size := 16;
   end;

   TransparentForm.Color := ColorKey;
   TransparentPanel.Color := ColorKey;
   TransparentForm.Show;
end;

////////////////////////////////////////////////////////////////////////////////
//                            MOTION DETECTOR TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.chkMotionDetectionEnabledClick(Sender: TObject);
begin
   videograbber.MotionDetector_Enabled := chkMotionDetectionEnabled.Checked;
end;

procedure TfrmMainForm.chkCompareRedClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_CompareRed := chkCompareRed.Checked;
end;

procedure TfrmMainForm.chkCompareGreenClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_CompareGreen := chkCompareGreen.Checked;
end;

procedure TfrmMainForm.chkCompareBlueClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_CompareBlue := chkCompareBlue.Checked;
end;

procedure TfrmMainForm.chk_GreyScaleClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_GreyScale := chk_GreyScale.Checked;
end;

procedure TfrmMainForm.chkReduceVideoNoiseClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_ReduceVideoNoise := chkReduceVideoNoise.Checked;
end;

procedure TfrmMainForm.edtGridChange(Sender: TObject);
begin
   VideoGrabber.MotionDetector_Grid := edtGrid.Text;
   if VideoGrabber.MotionDetector_IsGridValid then begin
      shpGridValid.Brush.Color := clLime;
      lblGridValid.Caption := 'valid';
   end
   else begin
      shpGridValid.Brush.Color := clRed;
      lblGridValid.Caption := 'invalid';
   end;
   mmoSensitivityGrid.Text := VideoGrabber.MotionDetector_Get2DTextGrid;
end;

procedure TfrmMainForm.updGlobalGridSensitivityClick(Sender: TObject;
  Button: TUDBtnType);
begin
   if Button = btNext then begin
      VideoGrabber.MotionDetector_GloballyIncOrDecSensitivity (1);
   end
   else begin
      VideoGrabber.MotionDetector_GloballyIncOrDecSensitivity (-1);
   end;
   edtGrid.Text := VideoGrabber.MotionDetector_Grid;
end;

procedure TfrmMainForm.btnApplyGridSizeClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_SetGridSize (StrToInt (edtGridColCount.Text), StrToInt (edtGridRowCount.Text));
   edtGrid.Text := VideoGrabber.MotionDetector_Grid;
   mmoSensitivityGrid.Text := VideoGrabber.MotionDetector_Get2DTextGrid;
end;

procedure TfrmMainForm.btnSetCellsSensitivityClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_SetCellSensitivity (StrToInt (edtXCell.Text), StrToInt (edtYCell.Text), StrToInt (edtCellSensitivity.Text));
   edtGrid.Text := VideoGrabber.MotionDetector_Grid;
   mmoSensitivityGrid.Text := VideoGrabber.MotionDetector_Get2DTextGrid;
end;

procedure TfrmMainForm.btnShowGridDialogClick(Sender: TObject);
begin
   if (VideoGrabber.CurrentState <> cs_Preview) and (VideoGrabber.CurrentState <> cs_Recording) then begin
      ShowMessage ('you should start preview or recording to see the video frame under the grid');
   end;
   if not VideoGrabber.MotionDetector_Enabled then begin
      ShowMessage ('you should enable the motion detector first (MotionDetector_Enabled = true) to see the video frame under the grid');
   end;
   if (VideoGrabber.MotionDetector_GridXCount > 30)  or (VideoGrabber.MotionDetector_GridYCount > 30) then begin
      ShowMessage ('the grid will be too dense to be edited through the dialog, you should use SetGridCell');
   end;
   VideoGrabber.MotionDetector_ShowGridDialog;
   edtGrid.Text := VideoGrabber.MotionDetector_Grid;
   mmoSensitivityGrid.Text := VideoGrabber.MotionDetector_Get2DTextGrid;
end;

procedure TfrmMainForm.chkTriggeredClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_Triggered := chkTriggered.Checked;
end;

procedure TfrmMainForm.btnTriggerNowClick(Sender: TObject);
begin
   VideoGrabber.MotionDetector_TriggerNow;
end;

procedure TfrmMainForm.VideoGrabberMotionDetected(Sender: TObject;
  GlobalMotionRatio: Double; MaxMotionCellX, MaxMotionCellY: Integer;
  FrameBitmap: TBitmap; FrameNumber: Cardinal; FrameTime: Int64;
  FrameId: Integer; var CaptureFrame: Boolean);
var
   MaxMotionXLocation, MaxMotionYLocation: LongInt;
begin
   shpMotionDetected.Brush.Color := clLime;
   edtMotionRatio.Text :=   FormatFloat ('0.000', VideoGrabber.MotionDetector_GlobalMotionRatio);

   edtMaxMotionXY.Text := 'X:' + IntToStr (MaxMotionCellX) + ' ; Y:' + IntToStr (MaxMotionCellY);
   if VideoGrabber.MotionDetector_GetCellLocation (MaxMotionCellX, MaxMotionCellY, MaxMotionXLocation, MaxMotionYLocation) then begin
      edtMaxMotionCoord.Text := 'x: ' + IntToStr (MaxMotionXLocation) + ' ; y: ' + IntToStr (MaxMotionYLocation);
   end;
   
   mmoMotionGrid.Text := VideoGrabber.MotionDetector_Get2DTextMotion;
   imgMotionDetected.Picture.Assign (FrameBitmap);
end;

procedure TfrmMainForm.VideoGrabberMotionNotDetected(Sender: TObject;
  FrameBitmap: TBitmap; FrameNumber: Cardinal; FrameTime: Int64;
  FrameId: Integer; var CaptureFrame: Boolean);
begin
   shpMotionDetected.Brush.Color := clGreen;
   edtMotionRatio.Text := '';
   mmoMotionGrid.Text := VideoGrabber.MotionDetector_Get2DTextMotion;
end;

////////////////////////////////////////////////////////////////////////////////
//                         "CLIP REENCODING" TAB
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.btnSourceVideoClipClick(Sender: TObject);
begin
   edtDestinationVideoClip.Text := '';
   dlgOpen.FileName := '*.mpg;*.mpeg;*.avi;*.wav;*.mp3;*.asf;*.wmv;*.vob';
   if dlgOpen.Execute then begin
      edtSourceVideoClip.Text := dlgOpen.FileName;
   end;
end;

procedure TfrmMainForm.btnDurationClick(Sender: TObject);
var
   Duration: int64;
   FrameCount: int64;
begin
   if VideoGrabber.AVIDuration (edtSourceVideoClip.Text, Duration, FrameCount) then begin
      edtDuration.Text := IntToStr (Duration);
   end;
end;

procedure TfrmMainForm.btnStartReencodingClick(Sender: TObject);
begin
   VideoGrabber.Reencoding_SourceVideoClip := edtSourceVideoClip.Text;
   VideoGrabber.Reencoding_NewVideoClip := edtDestinationVideoClip.Text;

   VideoGrabber.Reencoding_WMVOutput := chkWMVOutput.Checked;
   VideoGrabber.Reencoding_IncludeVideoStream := chkIncludeVideoStream.Checked;
   VideoGrabber.Reencoding_IncludeAudioStream := chkIncludeAudioStream.Checked;
   VideoGrabber.Reencoding_UseFrameGrabber := chkUseFrameGrabber.Checked;
   VideoGrabber.Reencoding_UseVideoCompressor := chkUseCurrentVideoCompressor.Checked;
   VideoGrabber.Reencoding_UseAudioCompressor := chkUseCurrentAudioCompressor.Checked;
   VideoGrabber.Reencoding_Method := TRecordingMethod (rdgReencodingMethod.ItemIndex);

   VideoGrabber.Reencoding_StartTime  := StrToInt64Def (edtStartTime.Text, -1);
   VideoGrabber.Reencoding_StopTime   := StrToInt64Def (edtStopTime.Text, -1);

   VideoGrabber.StartReencoding;
end;

procedure TfrmMainForm.btnStopReencodingClick(Sender: TObject);
begin
   VideoGrabber.StopReencoding;
end;

////////////////////////////////////////////////////////////////////////////////
//                                    MISC.
////////////////////////////////////////////////////////////////////////////////

procedure TfrmMainForm.edtStoragePathChange(Sender: TObject);
begin
   VideoGrabber.StoragePath := edtStoragePath.Text;
end;

procedure TfrmMainForm.ShowFormAboveVideo(Form: TForm);
begin
   if not assigned (Form) then Exit;
   Form.Top := Top + VideoGrabber.Top - Form.Height;
   Form.Left := Left + VideoGrabber.Left - Form.Width;
   if Form.Top < 0 then begin
      Form.Top := 0;
   end;
   if Form.Left < 0 then begin
      Form.Left := 0;
   end;
   Form.Show;
end;

procedure TfrmMainForm.RefreshVideoDeviceControls;
begin
   if csDestroying in ComponentState then Exit; // do nothing if the app terminates

   // let's refresh the controls according to the TVideoGrabber's states

   AssignListToComboBox (cboVideoDevices, VideoDevices, VideoGrabber.VideoDevice);
   AssignListToComboBox (cboAudioDevices, AudioDevices, VideoGrabber.AudioDevice);

   chkReduceDVFrameRate.Checked := VideoGrabber.DVReduceFrameRate;
   chkReduceDVFrameRate.Enabled := VideoGrabber.IsDigitalVideoIn;

   btnPauseRecording.Enabled := VideoGrabber.RecordingCanPause;
   btnResumeRecording.Enabled := VideoGrabber.RecordingCanPause;

   mnuSendDVCommands.Enabled := VideoGrabber.IsDVCommandAvailable;

   btnStreamDialog.Enabled := not VideoGrabber.IsDigitalVideoIn;
   btnCameraControlDialog.Enabled := VideoGrabber.IsCameraControlAvailable;
   btnVideoQualityDialog.Enabled := VideoGrabber.IsVideoQualityAvailable;
   btnVideoControlDialog.Enabled := VideoGrabber.IsVideoControlAvailable;

   cboAnalogVideoStandard.Enabled := VideoGrabber.IsAnalogVideoDecoderAvailable;
   cboVideoInputs.Enabled := VideoGrabber.IsVideoCrossbarAvailable;

   edtFrameRate.Text := FormatFloat ('0.00', VideoGrabber.FrameRate);

   rdgTunerInputType.ItemIndex := Integer (VideoGrabber.TVTunerInputType);
   edtCountryCode.Text := IntToStr (VideoGrabber.TVCountryCode);
   edtTVChannel.Text := IntToStr (VideoGrabber.TVChannel);
   LblTVTunerAvailable.Visible := not VideoGrabber.IsTVTunerAvailable;

   rdgCompressMode.Enabled := True;
   rdgCompressType.Enabled := True;

   if not VideoGrabber.AudioRecording then begin
      rdgCompressType.ItemIndex := 0;
      rdgCompressType.Enabled := False;
   end;

   lblFrameOverlayRequiresFrameGrabber.Visible := VideoGrabber.FrameGrabber = fg_Disabled;
   lblMotionDetectorRequiresFrameGrabber.Visible := VideoGrabber.FrameGrabber = fg_Disabled;

   if assigned (frmVideoControl) then begin
      frmVideoControl.RefreshControls;
   end;

   chkOpenDML.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   rdgCompressMode.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   rdgCompressType.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   cboVideoCompressors.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   btnVideoCompressorSettings.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   cboAudioCompressors.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   btnAudioCompressorSettings.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
   chkPreallocFile.Enabled := VideoGrabber.RecordingMethod = rm_AVI;
end;

procedure TfrmMainForm.SendVCRCommand (Sender: TObject);
begin
   // IT IS THE "TAG" PROPERTY OF EACH MENU ITEM THAT SELECTS THE CORRESPONDING TVCRCommand
   if VideoGrabber.SendDVCommand (TDVCommand (TMenuItem (Sender).Tag)) then begin
      mmoLog.Lines.Add ('DV command sent...');
   end
   else begin
      if not (VideoGrabber.CurrentState in [cs_Preview, cs_Recording]) then begin
         mmoLog.Lines.Add ('DV command failed. Preview must be running!');
      end
      else begin
         mmoLog.Lines.Add ('DV command failed.');
      end;
   end;
end;

procedure TfrmMainForm.VideoGrabberDVCommandCompleted(Sender: TObject;
  NewStateValue: Integer; NewStateLabel: String);
begin
   mmoLog.Lines.Add ('camcorder state: ' + NewStateLabel);
end;

procedure TfrmMainForm.VideoGrabberLog(Sender: TObject; LogType: TLogType;
  Severity, InfoMsg: String);
begin
   mmoLog.Lines.Add ('[' + Severity + '] ' + InfoMsg);
end;

procedure TfrmMainForm.VideoGrabberInactive(Sender: TObject);
begin
   mmoLog.Lines.Add ('(done.)');
end;

procedure TfrmMainForm.mnuAboutClick(Sender: TObject);
begin
   VideoGrabber.About;
end;

procedure TfrmMainForm.VideoGrabberResize(Sender: TObject);
var
   NewWidth: Integer;
   NewHeight: Integer;
begin
   NewWidth := VideoGrabber.Left + VideoGrabber.Width + 30;
   NewHeight := VideoGrabber.Top + VideoGrabber.Height + 60;
   if NewWidth < StartupWidth then begin
      NewWidth := StartupWidth;
   end;
   if NewHeight < StartupHeight then begin
      NewHeight := StartupHeight;
   end;
   if (NewWidth >= Width) and (NewHeight >= Height) then begin
      Width := NewWidth;
      Height := NewHeight;
   end;
end;

procedure TfrmMainForm.VideoGrabberDeviceLost(Sender: TObject);
begin
   mmoLog.Lines.Add ('DEVICE LOST!');
   AssignListToComboBox (cboVideoDevices, VideoDevices, VideoGrabber.VideoDevice);
   AssignListToComboBox (cboAudioDevices, AudioDevices, VideoGrabber.AudioDevice);
end;

procedure TfrmMainForm.VideoGrabberDiskFull(Sender: TObject);
begin
   mmoLog.Lines.Add ('DISK FULL!');
end;

procedure TfrmMainForm.VideoGrabberReinitializing(Sender: TObject);
begin
   mmoLog.Clear;
end;

procedure TfrmMainForm.VideoGrabberDeviceArrivalOrRemoval(Sender: TObject;
  IsDeviceArrival, IsVideoDevice: Boolean; DeviceName: String;
  DeviceIndex: Integer);
var
   AudioOrVideoDevice: string;
begin
   if IsVideoDevice then begin
      AudioOrVideoDevice:= 'video device ';
   end
   else begin
      AudioOrVideoDevice:= 'audio device ';
   end;
   if IsDeviceArrival then begin
      mmoLog.Lines.Add (AudioOrVideoDevice + 'arrival:');
   end
   else begin
      mmoLog.Lines.Add (AudioOrVideoDevice + 'removal:');
   end;
   mmoLog.Lines.Add (DeviceName);
   if IsVideoDevice then begin
      AssignListToComboBox (cboVideoDevices, VideoDevices, VideoGrabber.VideoDevice);
   end
   else begin
      AssignListToComboBox (cboAudioDevices, AudioDevices, VideoGrabber.AudioDevice);
   end;
end;

procedure TfrmMainForm.VideoGrabberVideoFromBitmapsFormatNeeded(
  Sender: TObject; out BitmapHandle: HBITMAP; out BMPorJPEGFile: String);
var
   SearchFiles: TSearchRec;
begin
   if Length(VideoGrabber.StoragePath) > 0 then begin // let's add a trailing slash if required
      if (VideoGrabber.StoragePath[Length(VideoGrabber.StoragePath)]) = '\' then begin
         SearchBmpPath := VideoGrabber.StoragePath;
      end
      else begin
         SearchBmpPath := VideoGrabber.StoragePath + '\';
      end;
   end
   else begin
      SearchBmpPath := '.\';
   end;
   if FindFirst (SearchBmpPath + '*.bmp', faAnyFile, SearchFiles) = 0 then begin
      // we can pass a bitmap handle to "BitmapHandle" or a BMP or JPEG file to BMPorJPEGFile
      // in this case we pass a BMP or JPEG file, so we set BitmapHandle = 0
      BMPorJPEGFile := SearchBmpPath + SearchFiles.Name;
      BitmapHandle := 0;
      FindClose (SearchFiles);
   end
   else begin
      mmoLog.Lines.Add ('');
      mmoLog.Lines.Add ('no bitmap files found in the StoragePath directory! Capture frames to BMP files first by using the frame grabber.');
   end;
end;

procedure TfrmMainForm.VideoGrabberVideoFromBitmapsNextFrameNeeded(
  Sender: TObject; FirstSample: Boolean; out BitmapHandle: HBITMAP;
  out BMPorJPEGFile: String; out EndOfData: Boolean);
var
   FileAvailable: Boolean;
begin
   FileAvailable := False;

   if FirstSample or (not SearchBmpFilesOpened) then begin // let's start from the first file

      if SearchBmpFilesOpened then begin
         FindClose (SearchBmpFiles);
         SearchBmpFilesOpened := False;
      end;
      if FindFirst (SearchBmpPath + '*.bmp', faAnyFile, SearchBmpFiles) = 0 then begin
         FileAvailable := True;
         SearchBmpFilesOpened := True;
      end
      else begin
         EndOfData := True;
      end;
   end
   else begin
      if FindNext (SearchBmpFiles) = 0 then begin
         FileAvailable := True;
      end
      else begin
         FindClose (SearchBmpFiles);
         SearchBmpFilesOpened := False;
         EndOfData := True;
      end;
   end;

   if FileAvailable then begin
      mmoLog.Lines.Add ('processing ' + SearchBmpPath + SearchBmpFiles.Name);
      // we can pass a bitmap handle to "BitmapHandle" or a BMP or JPEG file to BMPorJPEGFile
      // in this case we pass a BMP or JPEG file, so we set BitmapHandle = 0
      BMPorJPEGFile := SearchBmpPath + SearchBmpFiles.Name;
      BitmapHandle := 0;
   end;
end;

procedure TfrmMainForm.FormDestroy(Sender: TObject);
begin
   if SearchBmpFilesOpened then begin
      FindClose (SearchBmpFiles);
      SearchBmpFilesOpened := False;
   end;
end;

procedure TfrmMainForm.mnuExitClick(Sender: TObject);
begin
   Close;
end;

end.

