Option Strict Off
Option Explicit On
Module VBTools
	
	Public Structure PictDesc
		Dim cbSizeofStruct As Integer
		Dim picType As Integer
		Dim hImage As Integer
		Dim xExt As Integer
		Dim yExt As Integer
	End Structure
	
	Public Structure Guid
		Dim Data1 As Integer
		Dim Data2 As Short
		Dim Data3 As Short
		<VBFixedArray(7)> Dim Data4() As Byte
		
		'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1026"'
		Public Sub Initialize()
			ReDim Data4(7)
		End Sub
	End Structure
	
	Public Structure RECT
		'UPGRADE_NOTE: Left was upgraded to Left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
		Dim Left_Renamed As Integer
		Dim Top As Integer
		'UPGRADE_NOTE: Right was upgraded to Right_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
		Dim Right_Renamed As Integer
		Dim Bottom As Integer
	End Structure
	
    Public Structure TagBITMAP '14 bytes
        Dim bmType As Integer
        Dim bmWidth As Integer
        Dim bmHeight As Integer
        Dim bmWidthBytes As Integer
        Dim bmPlanes As Short
        Dim bmBitsPixel As Short
        Dim bmBits As Integer
    End Structure

    Public Structure BITMAPINFOHEADER
        Dim biSize As Integer
        Dim biWidth As Integer
        Dim biHeight As Integer
        Dim biPlanes As Short
        Dim biBitCount As Short
        Dim biCompression As Integer
        Dim biSizeImage As Integer
        Dim biXPelsPerMeter As Integer
        Dim biYPelsPerMeter As Integer
        Dim biClrUsed As Integer
        Dim biClrImportant As Integer
    End Structure

    Public Structure RGBQUAD
        Dim rgbBlue As Byte
        Dim rgbGreen As Byte
        Dim rgbRed As Byte
        Dim rgbReserved As Byte
    End Structure


    Public Structure BITMAPINFO
        Dim bmiHeader As BITMAPINFOHEADER
        Dim bmiColors As RGBQUAD
    End Structure

    Public Structure DIBSECTION
        Dim dsBm As TagBITMAP
        Dim dsBmih As BITMAPINFOHEADER
        <VBFixedArray(2)> Dim dsBitfields() As Integer
        Dim dshSection As Integer
        Dim dsOffset As Short
        Dim dsOffset2 As Short

        'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1026"'
        Public Sub Initialize()
            ReDim dsBitfields(2)
        End Sub
    End Structure

    Public Const MAX_PATH As Short = 260
    Public Const MAXDWORD As Short = &HFFFFS
    Public Const FILE_ATTRIBUTE_ARCHIVE As Short = &H20S
    Public Const FILE_ATTRIBUTE_DIRECTORY As Short = &H10S
    Public Const FILE_ATTRIBUTE_HIDDEN As Short = &H2S
    Public Const FILE_ATTRIBUTE_NORMAL As Short = &H80S
    Public Const FILE_ATTRIBUTE_READONLY As Short = &H1S
    Public Const FILE_ATTRIBUTE_SYSTEM As Short = &H4S
    Public Const FILE_ATTRIBUTE_TEMPORARY As Short = &H100S
    Public Const ERROR_NO_MORE_FILES As Short = 18
    Public Const INVALID_HANDLE_VALUE As Short = -1
    Public Const SRCCOPY = &HCC0020

    Public Structure FILETIME
        Dim dwLowDateTime As Integer
        Dim dwHighDateTime As Integer
    End Structure

    Public Structure WIN32_FIND_DATA
        Dim dwFileAttributes As Integer
        Dim ftCreationTime As FILETIME
        Dim ftLastAccessTime As FILETIME
        Dim ftLastWriteTime As FILETIME
        Dim nFileSizeHigh As Integer
        Dim nFileSizeLow As Integer
        Dim dwReserved0 As Integer
        Dim dwReserved1 As Integer
        <VBFixedString(MAX_PATH), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=MAX_PATH)> Public cFileName As String
        <VBFixedString(14), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=14)> Public cAlternate As String
    End Structure

    Public Structure TFileSearch
        Dim Handle As Integer
        Dim Opened As Boolean
        Dim Path As String
        Dim Data As WIN32_FIND_DATA
    End Structure

    Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Integer) As Integer
    'UPGRADE_NOTE: GetObject was upgraded to GetObject_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1016"'
    Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Integer, ByVal nCount As Integer, ByRef lpObject As DIBSECTION) As Integer
    Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Integer, ByVal hObject As Integer) As Integer
    Public Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Integer) As Integer
    Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As IntPtr, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As IntPtr, ByVal xSrc As Integer, ByVal ySrc As Integer, ByVal dwRop As Integer) As Integer
    Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal xSrc As Integer, ByVal ySrc As Integer, ByVal nSrcWidth As Integer, ByVal nSrcHeight As Integer, ByVal dwRop As Integer) As Integer
    Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Integer) As Integer
    Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer, ByVal crColor As Integer) As Integer
    Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer) As Integer
    Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer, ByRef lpPoint As POINTAPI) As Integer
    Public Declare Function GdiFlush Lib "gdi32" () As Integer
    Public Declare Function CreateDIBSection Lib "gdi32" (ByVal hdc As Integer, ByRef pBitmapInfo As BITMAPINFOHEADER, ByVal un As Integer, ByRef ppBits As Integer, ByVal hdl As Integer, ByVal dw As Integer) As Integer
    Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Integer, ByVal nWidth As Integer, ByVal crColor As Integer) As Integer
    Public Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Integer, ByVal nWidth As Integer, ByVal nEscapement As Integer, ByVal nOrientation As Integer, ByVal fnWeight As Integer, ByVal fdwItalic As Boolean, ByVal fdwUnderline As Boolean, ByVal fdwStrikeOut As Boolean, ByVal fdwCharSet As Integer, ByVal fdwOutputPrecision As Integer, ByVal fdwClipPrecision As Integer, ByVal fdwQuality As Integer, ByVal fdwPitchAndFamily As Integer, ByVal lpszFace As String) As Integer
    Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, ByRef lpFindFileData As WIN32_FIND_DATA) As Integer
    Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Integer, ByRef lpFindFileData As WIN32_FIND_DATA) As Integer
    Public Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Integer
    Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Integer) As Integer
    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1016"'
    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1016"'
    Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef pDestination As Object, ByRef pSource As Object, ByVal nBytes As Integer)
    Public Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (ByVal pDestination As Integer, ByVal Length As Integer)
    Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (ByRef lpPictDesc As PictDesc, ByRef riid As Guid, ByVal fPictureOwnsHandle As Integer, ByRef IPic As System.Drawing.Image) As Integer
    Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Integer, ByVal lpsz As String, ByVal un1 As Integer, ByVal n1 As Integer, ByVal n2 As Integer, ByVal un2 As Integer) As Integer
    Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Integer, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Integer) As Integer

    Public Const LR_CREATEDIBSECTION As Short = &H2000S
    Public Const LR_DEFAULTCOLOR As Short = &H0S
    Public Const LR_DEFAULTSIZE As Short = &H40S
    Public Const LR_LOADFROMFILE As Short = &H10S

    Public Const PS_SOLID As Integer = 0

    Public Structure POINTAPI
        Dim x As Integer
        Dim y As Integer
    End Structure

    Public Function AddLog(ByRef TxtBox As System.Windows.Forms.TextBox, ByRef Line As String) As Object
        TxtBox.Text = TxtBox.Text & vbCrLf & Line
        TxtBox.SelectionStart = Len(TxtBox.Text)
    End Function


    Public Sub SetOptionButtonByIndex(ByRef FrameName As Control, ByRef Indx As Short)
        Dim Ctrl As Control

        For Each Ctrl In FrameName.Controls
            If TypeOf Ctrl Is RadioButton Then
                If Ctrl.Tag = Indx Then
                    DirectCast(Ctrl, RadioButton).Checked = True
                End If
            End If
        Next Ctrl
    End Sub

    Public Sub EnableOrDisableFrameControls(ByRef FrameName As System.Windows.Forms.Control, ByRef EnableChkBox As Boolean)
        Dim Ctrl As Control

        For Each Ctrl In FrameName.Controls
            If TypeOf Ctrl Is CheckBox Then
                DirectCast(Ctrl, CheckBox).Enabled = EnableChkBox
            End If
        Next Ctrl
    End Sub

    Public Sub LoadTextBox(ByRef Dest As System.Windows.Forms.ListBox, ByRef Source As String)
        Dim Startpos As Integer
        Dim Endpos As Integer

        Startpos = 1

        Dest.Items.Clear()
        Endpos = InStr(Startpos, Source, vbCr)
        While (Endpos <> 0)
            Dest.Items.Add(Mid(Source, Startpos, Endpos - Startpos))
            Startpos = Endpos + 2 ' skip CR/LF
            Endpos = InStr(Startpos, Source, vbCr)
        End While
    End Sub

    Public Sub AssignListToComboBox(ByRef Dest As System.Windows.Forms.ComboBox, ByRef Source As String, ByRef Indx As Integer, Optional ByRef MaxIndxLimit As Integer = 0)
        Dim Startpos As Integer
        Dim Endpos As Integer
        Dim MaxIndxCount As Integer

        Startpos = 1

        If MaxIndxLimit > 0 Then
            MaxIndxCount = MaxIndxLimit
        Else
            MaxIndxCount = 99999
        End If

        Dest.Items.Clear()
        Endpos = InStr(Startpos, Source, vbCr)
        While (Endpos <> 0) And (MaxIndxCount > 0)
            Dest.Items.Add(Mid(Source, Startpos, Endpos - Startpos))
            Startpos = Endpos + 2 ' skip CR/LF
            Endpos = InStr(Startpos, Source, vbCr)
            MaxIndxCount = MaxIndxCount - 1
        End While
        If Indx < Dest.Items.Count Then
            Dest.SelectedIndex = Indx
        End If
    End Sub

    Public Sub FileSearch_Close(ByRef FileSearch As TFileSearch)
        If FileSearch.Opened Then
            FindClose(FileSearch.Handle)
            FileSearch.Opened = False
        End If
    End Sub

    Public Function FileSearch_NextFile(ByVal SearchPath As String, ByVal FileKind As String, ByVal RestartFromFirstFile As Boolean, ByRef FileSearch As TFileSearch) As String

        FileSearch_NextFile = ""

        If RestartFromFirstFile Or (Not FileSearch.Opened) Then

            FileSearch_Close(FileSearch) ' let's close any previous opened search

            If Len(SearchPath) > 0 Then ' let's add a trailing slash if required
                If Right(SearchPath, 1) = "\" Then
                    FileSearch.Path = SearchPath
                Else
                    FileSearch.Path = SearchPath & "\"
                End If
            Else
                FileSearch.Path = ".\"
            End If

            FileSearch.Handle = FindFirstFile(FileSearch.Path & FileKind, FileSearch.Data)
            If FileSearch.Handle <> INVALID_HANDLE_VALUE Then
                FileSearch_NextFile = FileSearch.Path & FileSearch.Data.cFileName
                FileSearch.Opened = True
            End If
        Else
            If FindNextFile(FileSearch.Handle, FileSearch.Data) <> 0 Then
                FileSearch_NextFile = FileSearch.Path & FileSearch.Data.cFileName
            Else
                FileSearch_Close(FileSearch)
            End If
        End If
    End Function
End Module
