//{{AFX_INCLUDES()
#include "videograbbervc6.h"
//}}AFX_INCLUDES
#if !defined(AFX_MAINFORM_H__DCE0471F_0FCF_4DE9_A4DB_CC9BBFA877D0__INCLUDED_)
#define AFX_MAINFORM_H__DCE0471F_0FCF_4DE9_A4DB_CC9BBFA877D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MainForm.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMainForm dialog

class CMainForm : public CDialog
{
	friend class CVideoSource;

// Construction
public:
	CMainForm(CWnd* pParent = NULL);   // standard constructor

	long BitmapOverlay_Width, BitmapOverlay_Height, BitmapOverlay_Left, BitmapOverlay_Top;
	long iFreeHandMouseDrawing;

	void Form_Load();
	void RefreshVideoDeviceControls();
	void SendDVCommand(TxDVCommand DvCommand);
	void ShowForm (CDialog *Dialog);

// Dialog Data
	CFileDialog	*m_dlgOpen;

	//{{AFX_DATA(CMainForm)
	enum { IDD = MainForm };
	CSliderCtrl	m_tbrPlayer;
	CEdit	m_mmoLog;
	CEdit	m_edtDVDateTime;
	CEdit	m_edtFrameCount;
	CEdit	m_edtStoragePath;
	CButton	m_btnFormAudio;
	CButton	m_btnFormRecording;
	CButton	m_btnFormNetworkStreaming;
	CButton	m_btnFormPlayer;
	CButton	m_btnFormFrameGrabber;
	CButton	m_btnFormMotionDetection;
	CButton	m_btnFormOverlays;
	CButton	m_btnFormVideoProcessing;
	CButton	m_btnFormDisplay;
	CButton	m_btnFormReencoding;
	CButton	m_btnFormTVTuner;
	CButton	m_btnFormVideoSource;
	CVideoGrabberVC6	m_VideoGrabber;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainForm)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMainForm)
	virtual BOOL OnInitDialog();
	afx_msg void OnbtnFormVideoSource();
	afx_msg void OnbtnFormAudio();
	afx_msg void OnbtnFormRecording();
	afx_msg void OnbtnFormNetworkStreaming();
	afx_msg void OnbtnFormPlayer();
	afx_msg void OnbtnFormFrameGrabber();
	afx_msg void OnbtnFormMotionDetection();
	afx_msg void OnbtnFormOverlays();
	afx_msg void OnbtnFormVideoProcessing();
	afx_msg void OnbtnFormDisplay();
	afx_msg void OnbtnFormReencoding();
	afx_msg void OnbtnFormTVTuner();
	afx_msg void OnChangeedtStoragePath();
	afx_msg void OnClose();
	afx_msg void OnmnuAbout();
	afx_msg void OnmnuDVff();
	afx_msg void OnmnuDVfreeze();
	afx_msg void OnmnuDVmodeShuttle();
	afx_msg void OnmnuDVplay();
	afx_msg void OnmnuDVplayFastestFwd();
	afx_msg void OnmnuDVplayFastestRev();
	afx_msg void OnmnuDVplaySlowestFwd();
	afx_msg void OnmnuDVplaySlowestRev();
	afx_msg void OnmnuDVrecord();
	afx_msg void OnmnuDVrecordFreeze();
	afx_msg void OnmnuDVrew();
	afx_msg void OnmnuDVstepFwd();
	afx_msg void OnmnuDVstepRev();
	afx_msg void OnmnuDVstop();
	afx_msg void OnmnuDVthaw();
	afx_msg void OnmnuRecordStrobe();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnAudioDeviceSelectedVideograbber();
	afx_msg void OnCopyPreallocDataCompletedVideograbber(LPCTSTR SourceFile, LPCTSTR DestFile, BOOL Success);
	afx_msg void OnCopyPreallocDataProgressVideograbber(long Percent, double Position, double Duration);
	afx_msg void OnCopyPreallocDataStartedVideograbber(LPCTSTR SourceFile, LPCTSTR DestFile);
	afx_msg void OnCreatePreallocFileCompletedVideograbber(LPCTSTR FileName, BOOL Success);
	afx_msg void OnCreatePreallocFileProgressVideograbber(long Percent, double Position, double Duration);
	afx_msg void OnCreatePreallocFileStartedVideograbber(LPCTSTR FileName);
	afx_msg void OnDeviceArrivalOrRemovalVideograbber(BOOL IsDeviceArrival, BOOL IsVideoDevice, LPCTSTR DeviceName, long DeviceIndex);
	afx_msg void OnDeviceLostVideograbber();
	afx_msg void OnDirectNetworkStreamingHostUrlVideograbber(LPCTSTR HostUrl, LPCTSTR HostName, long HostPort);
	afx_msg void OnDiskFullVideograbber();
	afx_msg void OnDVCommandCompletedVideograbber(long NewStateValue, LPCTSTR NewStateLabel);
	afx_msg void OnFrameCaptureCompletedVideograbber(long FrameBitmapHandle, long BitmapWidth, long BitmapHeight, long FrameNumber, double FrameTime, long DestType, LPCTSTR FileName, BOOL Success, long FrameId);
	afx_msg void OnFrameOverlayUsingDCVideograbber(long Dc, long FrameNumber, double FrameTime, long FrameId);
	afx_msg void OnFrameOverlayUsingDIBVideograbber(long FrameBitmapHandle, long FrameNumber, double FrameTime, long FrameId);
	afx_msg void OnFrameProgressVideograbber(long FrameNumber, double FrameTime, long FrameId);
	afx_msg void OnInactiveVideograbber();
	afx_msg void OnLogVideograbber(long LogType, LPCTSTR Severity, LPCTSTR InfoMsg);
	afx_msg void OnMotionDetectedVideograbber(double GlobalMotionRatio, long MaxMotionCellX, long MaxMotionCellY, long FrameBitmapHandle, long FrameNumber, double FrameTime, long FrameId, BOOL FAR* CaptureFrame);
	afx_msg void OnMotionNotDetectedVideograbber(long FrameBitmapHandle, long FrameNumber, double FrameTime, long FrameId, BOOL FAR* CaptureFrame);
	afx_msg void OnMouseDownVideograbber(long VideoWindow, long Button, long x, long y);
	afx_msg void OnMouseMoveVideograbber(long VideoWindow, long x, long y);
	afx_msg void OnMouseUpVideograbber(long VideoWindow, long Button, long x, long y);
	afx_msg void OnPlayerOpenedVideograbber();
	afx_msg void OnPreviewStartedVideograbber();
	afx_msg void OnRecordingCompletedVideograbber(LPCTSTR FileName, BOOL Success);
	afx_msg void OnRecordingReadyToStartVideograbber();
	afx_msg void OnRecordingStartedVideograbber(LPCTSTR FileName);
	afx_msg void OnReencodingCompletedVideograbber(LPCTSTR SourceFile, LPCTSTR DestFile, BOOL Success);
	afx_msg void OnReencodingProgressVideograbber(long Percent, double Position, double Duration);
	afx_msg void OnReencodingStartedVideograbber(LPCTSTR SourceFile, LPCTSTR DestFile);
	afx_msg void OnReinitializingVideograbber();
	afx_msg void OnResizeVideograbber();
	afx_msg void OnResizeVideoVideograbber(long SourceWidth, long SourceHeight);
	afx_msg void OnTVChannelScanCompletedVideograbber();
	afx_msg void OnTVChannelScanStartedVideograbber(long MinChannel, long MaxChannel);
	afx_msg void OnTVChannelSelectedVideograbber(long Channel, BOOL Locked, long DefaultVideoFrequency, long OverriddenVideoFrequency, long TunerVideoFrequency, long TunerAudioFrequency);
	afx_msg void OnVideoDeviceSelectedVideograbber();
	afx_msg void OnVideoFromBitmapsFormatNeededVideograbber(long FAR* BitmapHandle, BSTR FAR* BMPorJPEGFile);
	afx_msg void OnVideoFromBitmapsNextFrameNeededVideograbber(BOOL FirstSample, long FAR* BitmapHandle, BSTR FAR* BMPorJPEGFile, BOOL FAR* EndOfData);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFORM_H__DCE0471F_0FCF_4DE9_A4DB_CC9BBFA877D0__INCLUDED_)

